# ggcmpy -- Python utilities for the OpenGGCM Global Magnetosphere Code

[![Actions Status][actions-badge]][actions-link]
[![Documentation Status][rtd-badge]][rtd-link]

[![PyPI version][pypi-version]][pypi-link]
[![PyPI platforms][pypi-platforms]][pypi-link]

<!-- [![Conda-Forge][conda-badge]][conda-link] -->

[![GitHub Discussion][github-discussions-badge]][github-discussions-link]

<!-- prettier-ignore-start -->
[actions-badge]:            https://github.com/unh-hpc/ggcmpy/workflows/CI/badge.svg
[actions-link]:             https://github.com/unh-hpc/ggcmpy/actions
[conda-badge]:              https://img.shields.io/conda/vn/conda-forge/ggcmpy
[conda-link]:               https://github.com/conda-forge/ggcmpy-feedstock
[github-discussions-badge]: https://img.shields.io/static/v1?label=Discussions&message=Ask&color=blue&logo=github
[github-discussions-link]:  https://github.com/unh-hpc/ggcmpy/discussions
[pypi-link]:                https://pypi.org/project/ggcmpy/
[pypi-platforms]:           https://img.shields.io/pypi/pyversions/ggcmpy
[pypi-version]:             https://img.shields.io/pypi/v/ggcmpy
[rtd-badge]:                https://readthedocs.org/projects/ggcmpy/badge/?version=latest
[rtd-link]:                 https://ggcmpy.readthedocs.io/en/latest/?badge=latest

<!-- prettier-ignore-end -->

[Documentation](https://ggcmpy.readthedocs.io/)

<!-- SPHINX-START -->

The ggcmpy package aims to be the place to collect various OpenGGCM related
tools.

- Support for reading OpenGGCM data files as Xarray datasets.

  Xarray is essentially an extension of numpy arrays, adding additional
  information like dimension names and coordinates, and making many data
  analysis tasks much easier. This package allows to read OpenGGCM binary files
  (`.iof`, `.3df`, `.p[xyz]_N`) simply by `ds = xr.open_dataset(filename)`.

- OpenGGCM-specific Xarray extensions
  - for now, this is limited to providing the `mlts` and `colats` coordinates in
    addition to the standard `longs`, `lats`.

- (TBD): OpenGGCM specific plotting support

- (TBD): Setting up an OpenGGCM run
  - Generating a runme
  - Generating a non-uniform grid
  - Preparing event solar wind data

- (external): Support for reading OpenGGCM XDMF/HDF5 data is available through
  [xarray-pschdf5](https://github.com/psc-code/xarray-pschdf5)

- (external): Support for reading OpenGGCM ADIOS2 data is available through
  [xarray-adios2](https://github.com/unh-hpc/xarray-adios2)

Needless to say, there is a lot of work the remains to be done, feedback /
requests and help are always appreciated!

#define FSEEKABLE

#ifdef FSEEKABLE
#define HAVE_FSEEK 1
#define HAVE_FTELL 1
#endif

  subroutine seek(unit,offset,whence,status)
    implicit none
    integer unit
    INTEGER*8 offset
    integer whence
    integer status
    !f2py intent(in) unit
    !f2py intent(in) offset
    !f2py integer optional, intent(in) :: whence=0
    !f2py intent(out) status
    !Non-zero exit status on exit if this routine fails
    status = -1

#ifdef HAVE_FSEEK
    call fseek(unit,offset,whence,status)
#else
    read(unit,'()',ADVANCE='NO',POS=offset,IOSTAT=status)
#endif
    return

  end subroutine seek

  subroutine tell(unit,offset)
    implicit none
    integer unit
    INTEGER*8 offset
    !f2py intent(in) unit
    !f2py intent(out) offset
    offset = -1

#ifdef HAVE_FTELL
    call ftell(unit,offset)
#else
    inquire(UNIT=unit,POS=offset)
#endif

    return
  end subroutine tell

  subroutine freefileunit(funit)
    IMPLICIT NONE
    integer funit
    !f2py intent(out) funit

    logical isopen
    integer i

    !look for a free file unit
    do i=10,10000
       if((i.ge.100) .and. (i.le.102))then
          !some implementations reserve these units
          cycle
       endif
       inquire(unit=i,opened=isopen)
       if(.not.isopen)then
          funit=i
          exit
       endif
    enddo

  end subroutine freefileunit

  subroutine frewind(funit,debug)
    IMPLICIT NONE
    integer :: funit
    !f2py intent(in) funit
    integer debug
    !f2py integer optional debug=0
    if(debug.gt.0) print*,"Rewinding unit:",funit

    rewind(funit)
  end subroutine frewind


  subroutine fbackspace(funit,debug)
    IMPLICIT NONE
    integer :: funit
    !f2py intent(in) funit
    integer debug
    !f2py integer optional debug=0

    if(debug.gt.1) print*,"backspacing unit:",funit

    backspace(funit)
  end subroutine fbackspace

  subroutine fopen(funit,fname,debug)
    !TODO: open as binary or for appending
    ! open a fortran file
    IMPLICIT NONE
    integer :: funit
    !f2py intent(out) funit
    character(Len=*) :: fname
    !f2py intent(in) fname
    integer debug
    !f2py integer optional debug=0
    logical isopen
    integer openstat
    character*10 access_method

#ifdef HAVE_STREAM
    access_method = 'STREAM'
#else
    access_method = 'SEQUENTIAL'
#endif

    inquire(file=fname,opened=isopen,number=funit)
    if(isopen)then
       if(debug.gt.0) print*,"file already opened:",fname
       if(debug.gt.0) print*,"associated unit:",funit
       return
    endif

    call freefileunit(funit)
    open(unit=funit,file=fname,action='READ',status='UNKNOWN',form='FORMATTED', &
         access=access_method,IOSTAT=openstat)

    if (openstat.ne.0) then
      funit = -1 * openstat
    endif

    if(debug.gt.0) print*,"opened file:",fname
    if(debug.gt.0) print*,"associated unit:",funit
    if(debug.gt.0) print*,"access method:",access_method

  end subroutine fopen

  subroutine fadvance_one_line(success,funit,debug)
    !advance one line in the file
    IMPLICIT NONE
    integer :: success,funit
    !f2py intent(out) success
    !f2py intent(in) funit
    character(Len=1) :: a
    integer debug
    !f2py integer optional debug=0
    if(debug.gt.1) print*,"advancing unit by 1 line:",funit


    success=0
    read(funit,'(A)',err=777,end=777) a
    success=1
    777 continue ! continue on error

  end subroutine fadvance_one_line

  subroutine fisopen(funit,isopen,debug)
    ! Check if a fortran file unit is open
    integer :: funit
    !f2py intent(in) funit
    integer :: isopen
    !f2py intent(out) isopen
    integer :: debug
    !f2py integer optional debug=0
    logical o

    inquire(unit=funit,opened=o)
    if(o)then
       isopen=1
    else
       isopen=0
    endif
  end subroutine fisopen

  subroutine fclose(funit,debug)
    ! close a fortran file
    integer :: funit
    !f2py intent(in) funit
    integer debug
    !f2py integer optional debug=0
    logical isopen
    if(debug.gt.0) print*,"closing unit:",funit

    inquire(unit=funit,opened=isopen)
    if(isopen)then
       close(unit=funit)
    else
       print*,"Cannot close unit that isn't open",funit
    endif

  end subroutine fclose

  !TODO: fseek a binary unit

module constants_m
   implicit none
   private

   real, parameter, public :: pi = 3.1415927, pi2 = 6.2831855

   real, parameter, public :: sig0 = 0.11889699
   real, parameter, public :: phi0= 0.13037126E+10
   real, parameter, public :: j0 = 0.38188455E-05
   real, parameter, public :: n0 = 0.10000000E+11
   real, parameter, public :: p0 = 0.37193298E-03
   real, parameter, public :: v0 = 6692976.5

   ! MPI tags
   integer, parameter, public :: ID_IONEGO = 1000
   integer, parameter, public :: ID_IOALL = 2000
   integer, parameter, public :: ID_POT = 3000

   integer, parameter, public :: tty = 0

end module constants_m

module f2py
   ! wrappers for OpenGGCM routines that can not be directly wrapped by f2py
   ! due to use of Fortran types, etc
   implicit none
   private

   public :: epoch1966, cotr

contains

   subroutine epoch1966(dsecs, iy, mo, id, ih, mi, sec)
      use date_lib, only: epoch1966_ => epoch1966
      real*8, intent(out) :: dsecs
      !f2py intent(out) :: dsecs
      integer, intent(in) :: iy, mo, id, ih, mi
      real, intent(in) :: sec

      call epoch1966_(dsecs, iy, mo, id, ih, mi, sec, 0)
   end subroutine epoch1966

   subroutine cotr(dsecs, cfr, cto, r1, r2)
      use new_cotr, only: cotr_set, cotr_ => cotr, transform
      real*8, intent(in) :: dsecs
      character*3, intent(in) :: cfr, cto
      real, dimension(3), intent(in) :: r1
      real, dimension(3), intent(out) :: r2

      type(transform) :: tran

      call cotr_set(dsecs, tran)
      call cotr_(tran, cfr, cto, r1(1), r1(2), r1(3), r2(1), r2(2), r2(3))
   end subroutine cotr

end module f2py

!......  This module contains the ionosphere potential solver
!        and some helper routines.
!        Completely self contained, no side effects through common
!        blocks, but takes hash-constant parameters.
!        Temp storage must be maintained between calls.
!
!        JR  3/7/2000:  from ionos08.for
!
! ---------------------------------------------------------------------
subroutine io4(ijob,nx,ny,ngord,npany,sigp,sigh,xjpa,pot,nphi,nthe,wk,nwk, t1,t2,t3)
! ---------------------------------------------------------------------
   real sigp(*),sigh(*),xjpa(*),pot(*),wk(*)
   real t1(nthe/2,nphi)
   real t2(nthe/2,nphi)
   real t3(nthe/2,nphi)
   parameter (pi=3.1415926)

   mx=nthe/2
   my=nphi
   xx2=pi*(89.95)/180.0

!    call second1(cpu1)

!.... initialize
   if(ijob.eq.0) then
      call iosol2(0,nx,ny,xx2,ngord,npany,t1,t2,t3,mx,my,wk(1),nwk)
      call iosol2(0,nx,ny,xx2,ngord,npany,t1,t2,t3,mx,my,wk(1+nwk),nwk)
   endif

!.... set up matrix and factor it
   if(ijob.eq.1) then
      call trio1n(sigp,t1,nphi,nthe,mx,1.0)
      call trio1n(sigh,t2,nphi,nthe,mx,1.0)
      call iosol2(1,nx,ny,xx2,ngord,npany,t1,t2,t3,mx,my,wk(1),nwk)
      call trio1s(sigp,t1,nphi,nthe,mx,1.0)
      call trio1s(sigh,t2,nphi,nthe,mx,1.0)
      call iosol2(1,nx,ny,xx2,ngord,npany,t1,t2,t3,mx,my,wk(1+nwk),nwk)
   endif

!.... solve equation with matrix factored
   if(ijob.eq.2) then
      call trio1n(xjpa,t3,nphi,nthe,mx,-1.0)
      call iosol2(2,nx,ny,xx2,ngord,npany,t1,t2,t3,mx,my,wk(1),nwk)
      call iosol2(4,nx,ny,xx2,ngord,npany,t1,t2,t3,mx,my,wk(1),nwk)
      call trio2n(t3,pot,nthe,nphi,mx)
      call trio1s(xjpa,t3,nphi,nthe,mx,-1.0)
      call iosol2(2,nx,ny,xx2,ngord,npany,t1,t2,t3,mx,my,wk(1+nwk),nwk)
      call iosol2(4,nx,ny,xx2,ngord,npany,t1,t2,t3,mx,my,wk(1+nwk),nwk)
      call trio2s(t3,pot,nthe,nphi,mx)
   endif

!    call second1(cpu2)
!      write(0,*)'io4: ',ijob,cpu2-cpu1

   return
end
! ------------------------------------------------------------------
subroutine trio1n(a,b,np,nt,nt2,s)
! ------------------------------------------------------------------
!.... transpose array for the northern hemisphere
   real a(np,nt),b(nt2,np)
   it2=1
   do it=1,nt2
      do ip=1,np
         b(it,ip)=a(ip,it2)*s
      end do
      it2=it2+1
   end do
   return
end
! ------------------------------------------------------------------
subroutine trio2n(a,b,nt,np,nt2)
! ------------------------------------------------------------------
!.... copy back and flip into total potential array, northern part
   real a(nt2,np),b(np,nt)
   it2=1
   do it=1,nt2
      do ip=1,np
         b(ip,it2)=a(it,ip)
      end do
      it2=it2+1
   end do
   return
end
! ------------------------------------------------------------------
subroutine trio1s(a,b,np,nt,nt2,s)
! ------------------------------------------------------------------
!.... transpose array for the southern hemisphere
   real a(np,nt),b(nt2,np)
   it2=nt
   do it=1,nt2
      do ip=1,np
         b(it,ip)=a(ip,it2)*s
      end do
      it2=it2-1
   end do
   return
end
! ------------------------------------------------------------------
subroutine trio2s(a,b,nt,np,nt2)
! ------------------------------------------------------------------
!.... copy back and flip into total potential array, southern part
   real a(nt2,np),b(np,nt)
   it2=nt
   do it=1,nt2
      do ip=1,np
         b(ip,it2)=a(it,ip)
      end do
      it2=it2-1
   end do
   return
end
! ------------------------------------------------------------------
subroutine iosol2(ijob,nx,ny,xx2,mgord,mpany,sigp,sigh,xjpa,mx,my,wk,mwk)
! ---------------------------------------------------------------------
!   galerkin pseudospectral routine to solve the ionosphere
!   potential equation
!
!     d/dx( a(x,y) * df/dx + b(x,y) * df/dy )
!   + d/dy( c(x,y) * df/dx + d(x,y) * df/dy )  =  rhs
!
!   with boundary conditions:  f(0,.)=0, df(xx2,.)/dx=0, periodic y
!
!   basis functions are:
!
!   B(i,j,x,y) = H(mod(i-1,4),x) * F(j,y) , i=1,..,4*nx;  j=1,...,2*ny
!
!   with:   H(i,x) : Hermite polynominal with support t1,..,t2
!                    cubics with continuous first derivative
!           F(j,y) : sin((((j-1)/2)+1)*y), j odd
!                    cos( ((j-1)/2   )*y), j even
!
!   nx:     no of panels in x (theta)
!   ny:     no of modes in y (phi)
!   xx2:    upper x boundary (radians)
!   mgord:  order of gauss integration
!   mpany:  no of panels in y for integrations
!   sigp:   array holding pedersen conductivity
!   sigh:   array holding hall conductivity
!   xjpa:   array holding parallel current
!           for ijob=4: potential
!   mx,my:  dimensions of sigp,sigh,xjpa
!   wk:     workspace, must not be touched between calls
!   mwk:    size of workspace, will stop if not enough
!
!... ijob=0   initialize
!... ijob=1   set up global matrix and factor it
!... ijob=2   set up rhs and solve
!... ijob=4   evaluate solution on reg grid xjpa
!
!    written by: Jimmy Raeder, IGPP/UCLA, Nov 1992
!
   use constants_m, only: tty
   real wk(*),sigp(mx,my),sigh(mx,my),xjpa(mx,my)

   common /iosola/neq,nb,ndof,ndof1,ny2,ny4,na,ngord,npany, nwa, &
         nwrhs,nwem,nwleq,nwemat,ncof,ncofr,nwcof,nwcofr,nwcfx, nwcfy, &
         nwtx,nwsol
   character*80 rec
   save
   parameter (pi=3.1415926)


!... initialize
   if(ijob.eq.0) then
      ndof=4*2*ny
      ndof1=ndof+1
      ny2=2*ny
      ny4=2*ny2
      npany=mpany
      ngord=mgord
!.... do a mock assembly to determine neq and bandwidth
      neq=0
      nb=0
      do kx=1,nx
         do jy=1,ndof
            if(kx.eq.1) then
               iy=jy
            else
               iy=ny4*(kx-1)+jy
            endif
            do jx=1,ndof
               if(kx.eq.1) then
                  ix=jx
               else
                  ix=ny4*(kx-1)+jx
               endif
               nb=max0(nb,iabs(ix-iy))
               neq=max0(neq,ix)
               neq=max0(neq,iy)
            end do
         end do
      end do
!      write(0,*)' iosol2 neq,nb,na ',neq,nb,neq*(nb+nb+1)
!..... workspace assignments
      nw = 1
      nwtx = nw
      nw = nw + nx+1
      nwa = nw
      na = neq*(nb+nb+1)
      nw = nw + na
      nwrhs = nw
      nw = nw + neq
      nwem = nw
      nw = nw + (ndof+1)*ndof
      nwleq = nw
      nw = nw + neq*(nb+1)
      nwemat = nw
      nw = nw + 4*npany*ngord*ny
      nwcof = nw
      ncof = 8*ngord*ngord*nx*npany
      nw = nw + ncof
      ncofr = 3*ngord*npany
      nwcofr = nw
      nw = nw + ncofr
      nwsol = nw
      nw = nw + neq
      nwcfx = nw
      nw = nw + 5*mx
      nwcfy = nw
      nw = nw + 2*ny*my

!      write(tty,*)'iosol2 nw mwk neq nb ',nw,mwk,neq,nb
      if(nw.gt.mwk) call death()
!.... create panels in x (theta)
      x1=0.0
      x2=xx2
      if (.false.) then
         do 120 kx=1,nx+1
            if (.false.) then
               if(kx.le.60) then
                  wk(nwtx+kx-1)=(pi/180.0)*0.5*float(kx-1)
                  xxl=wk(nwtx+kx-1)
               else
                  wk(nwtx+kx-1)=wk(nwtx+60-1)+(xx2-xxl)*float(kx-60)/float(nx-60+1)
               endif
!      write(0,*)' th-elements ',kx,s,wk(nwtx+kx-1)*57.29
            endif
            if (.false.) then
               s=float(kx-1)/float(nx)
               s1=s*s
               s2=0.5*s
               ss=amax1(s1,s2)
               wk(nwtx+kx-1)=x1+(x2-x1)*ss
!      write(0,*)' th-elements ',kx,s,wk(nwtx+kx-1)*57.29
            endif
            if (.false.) then
               s=float(kx-1)/float(nx)
               s1=s*s
               s2=0.5*s
               ss=amax1(s1,s2)
               wk(nwtx+kx-1)=x1+(x2-x1)*ss
!      write(0,*)' th-elements ',kx,s,wk(nwtx+kx-1)*57.29
            endif
120      continue
      endif
!      write(0,*)'call mkel ',nx,nwtx
      call mkel(nx+1,wk(nwtx),x1,x2)
!      write(0,*)'call mkgaus ',nx,ny,npany,ngord,nwtx,nwcof,nwcofr
      call mkgaus(nx,ny,npany,ngord,wk(nwtx),wk(nwcof),wk(nwcofr))
!      write(0,*)'call mkcoe1',nx,ny,npany,ngord,nwtx,nwcof,nwcofr
      call mkcoe1(nx,ny,npany,ngord,wk(nwtx),wk(nwcof),wk(nwcofr),xx2,sigp,sigh,xjpa,mx,my,0)
!      write(0,*)'calli eval2 ',nwtx,nwsol,neq,nx,ny,mx,my,nwcfx,nwcfy
      call eval2(0,wk(nwtx),wk(nwsol),neq,nx,ny,xjpa,mx,my,xx2,wk(nwcfx),wk(nwcfy))
!      write(0,*)'eval2 back'
      call emat(wk(nwem),wk(nwtx),1,nx,ny,ndof,ngord,npany, wk(nwemat), 0 ,wk(nwcof),wk(nwcofr))
      return
   endif



   if(ijob.eq.1.or.ijob.eq.2) then

      call xzero(wk(nwrhs),neq)
      if(ijob.eq.1)call xzero(wk(nwa),na)

      call mkcoe1(nx,ny,npany,ngord,wk(nwtx),wk(nwcof),wk(nwcofr),xx2, sigp,sigh,xjpa,mx,my,ijob)

!..... assemble global matrix or rhs
      do k=1,nx
         call xzero(wk(nwem),ndof*ndof1)
         call emat(wk(nwem),wk(nwtx),k,nx,ny,ndof,ngord,npany, wk(nwemat),ijob,wk(nwcof),wk(nwcofr))
         call addmat(wk(nwa),wk(nwrhs),wk(nwem),neq,nb,ndof,ny4,k,ijob)
      end do

!.... factor matrix
      if(ijob.eq.1) then
         call leqt1b(wk(nwa),neq,nb,nb,neq,wk(nwsol),1,neq,1,wk(nwleq),ier)
         if(ier.ne.0) then
            write(tty,*)' leqt1b ier= ',ier
         endif
!      if(ier.eq.129) call death()
      endif

!.... solve equations
      if(ijob.eq.2) then
         call xcopy(wk(nwrhs),wk(nwsol),neq)
         call leqt1b(wk(nwa),neq,nb,nb,neq,wk(nwsol),1,neq,2,wk(nwleq),ier)
         if(ier.ne.0) then
            write(tty,*)' leqt1b ier= ',ier
         endif
         if(ier.eq.129) call death()
      endif

   endif

   if(ijob.eq.4) then
      call eval2(4,wk(nwtx),wk(nwsol),neq,nx,ny,xjpa,mx,my,xx2,wk(nwcfx),wk(nwcfy))
   endif


   return
end
! -----------------------------------------------------------------------
subroutine mkel(nn,w,x1,x2)
! -----------------------------------------------------------------------
   real w(nn)
   deg=45.0/atan(1.0)
   do i=1,nn
      w(i)=deg*(x1+float(i-1)*(x2-x1)/float(nn-1))
   end do
   if (.true.) then
      s=0.0
      do i=2,nn
         t=deg*(x1+float(i-1)*(x2-x1)/float(nn-1))
         s=s+(1.0/xmkel(t))
      end do
      w(1)=x1
      do i=2,nn
         w(i)=w(i-1)+(s/xmkel(w(i)))
      end do
      s=(x2-x1)/(w(nn)-w(1))
      do i=2,nn
         w(i)=x1+s*(w(i)-x1)
      end do
      if (.false.) then
         dd=0.0
         do i=1,nn
            if(i.gt.1)dd=w(i)-w(i-1)
            write(0,'(a,i3,1x,3(1x,g12.5))')'mkel ',i,deg*w(i),deg*dd,deg*xmkel(w(i))*dd
         end do
      endif
   endif
   if (.false.) then
      f=1.0
      do it=1,10000
         do i=2,nn-1
            s1=0.5*(w(i-1)+w(i))
            s2=0.5*(w(i)+w(i+1))
            d1=w(i)-w(i-1)
            d2=w(i+1)-w(i)
            df1=d1*xmkel(s1)
            df2=d2*xmkel(s2)
!      if(mod(it,500).eq.0)write(0,*)'mkel: ',i,df1,df2,d1,d2
            if(df1.gt.df2) then
               w(i)=w(i)-0.2*f*d1
            else
               w(i)=w(i)+0.2*f*d2
            endif
         end do
         if(mod(it,1000).eq.0)f=0.8*f
      end do
      dd=0.0
      do i=1,nn
         if(i.gt.1)dd=w(i)-w(i-1)
         write(0,'(a,i3,1x,3(1x,g12.5))')'mkel ',i,w(i),dd,xmkel(w(i))*dd
      end do
      do i=1,nn
         w(i)=w(i)/deg
      end do
   endif
   return
end
!-----------------------------------------------------------------------
real function xmkel(x)
!-----------------------------------------------------------------------
   d=-1.0*( ((x-40.0)/13.0)**2 )
   xmkel = 1.0 + 2.0*exp( d ) - 0.85*x/90.0
   return
end
!-----------------------------------------------------------------------
subroutine eval2(ijob,tx,sol,neq,nx,ny,pot,mx,my,xend,cfx,cfy)
!-----------------------------------------------------------------------
   real tx(*),sol(*),pot(mx,my),cfx(5,mx),cfy(2*ny,my)
   real bb(4),bbx(4)
   parameter (pi=3.1415926)

!      write(0,*)'evale: ',neq,nx,ny,mx,my,xend
   ny2=2*ny
   ny4=2*ny2
   if(ijob.eq.0) then
      do ix=1,mx
         x=xend*float(ix-1)/float(mx-1)
         kx=nx
!... find x interval
         do j=1,nx
            if(tx(j).le.x.and.tx(j+1).ge.x) kx=j
         end do
         call hermite(bb,bbx,x,tx(kx),tx(kx+1))
         cfx(1,ix)=bb(1)
         cfx(2,ix)=bb(2)
         cfx(3,ix)=bb(3)
         cfx(4,ix)=bb(4)
         cfx(5,ix)=float(kx)+0.1
      end do
      do iy=1,my
         y=(-pi)+2.0*pi*float(iy-1)/float(my-1)
         do jy=1,ny2
            itmp1=(jy-1)/2
            itmp2=mod(jy,2)
            tmp1=float(itmp1+itmp2)
            if(itmp2.eq.0) fy=cos(y*tmp1)
            if(itmp2.eq.1) fy=sin(y*tmp1)
            cfy(jy,iy)=fy
         end do
      end do
      return
   endif


   if(ijob.eq.4) then
      do iy=1,my
         do ix=1,mx
            kx=cfx(5,ix)
            pot(ix,iy)=0.0
            do j1=1,ny2
               do i1=1,4
                  jy=ny2*(i1-1)+j1
                  if(kx.eq.1) then
                     ky=jy
                  else
                     ky=ny4*(kx-1)+jy
                  endif
                  pot(ix,iy)=pot(ix,iy)+sol(ky)*cfx(i1,ix)*cfy(j1,iy)
               end do
            end do
         end do
      end do
   endif

   return
end
! -----------------------------------------------------------------------
subroutine mkcoe1(nx,ny,npany,ngord,tx,coef,coefr,xx2,sigp,sigh,xjpa,mx,my,ijob)
! -----------------------------------------------------------------------
! .... create gauss legendre integration points and weights
   use constants_m, only: tty
   real coef(ngord,ngord,npany,nx,8)
   real coefr(ngord,npany,3)
   real sigp(mx,my),sigh(mx,my),xjpa(mx,my)
   real tx(*)
   parameter (NIOGO=4) ! max order of gauss legendre integration
   parameter (NIOX=40) ! max no of panels in theta for one hemisphere
   common /mkcoea/sico(3,NIOGO,NIOX)
   common /mkcoeb/xa,xb,ya,yb,hx,hy,hxi,hyi
   common /mkcoec/mxm1,mym1
   parameter (pi=3.1415926)

   if (ngord .gt. NIOGO) then
      write(tty,*)' mkcoe1: ngord too large ',ngord,NIOGO
      call death()
   endif
   if (nx .gt. NIOX) then
      write(tty,*)' mkcoe1: nx too large ',nx,NIOX
      call death()
   endif

!      call minmax(sigp,mx*my,zmin,zmax)
!      write(tty,*)' minmax sigp  ',zmin,zmax
!      call minmax(sigh,mx*my,zmin,zmax)
!      write(tty,*)' minmax sigh  ',zmin,zmax
!      call minmax(xjpa,mx*my,zmin,zmax)
!      write(tty,*)' minmax xjpa  ',zmin,zmax
!
!      write(0,*)'mkcoe:',ijob,mx,my,nx,ny,xx2

   if(ijob.eq.0) then
      xa=0.0
      xb=xx2
      ya=(-pi)
      yb=pi
      mxm1=mx-1
      hx=(xb-xa)/float(mxm1)
      hxi=1.0/hx
      mym1=my-1
      hy=(yb-ya)/float(mym1)
      hyi=1.0/hy
!.... make sin/cos/sini table
      do kx=1,nx
         do igx=1,ngord
            x=coef(igx,1,1,kx,2)
            st=sin(x)
            ct=cos(x)
            si=2.0*ct/sqrt(1.0+3.0*ct*ct)
            sico(1,igx,kx)=st
            sico(2,igx,kx)=ct
            sico(3,igx,kx)=si
         end do
      end do
      return
   endif



   if(ijob.eq.1) then
      do kx=1,nx
         do igx=1,ngord
            x=coef(igx,1,1,kx,2)
            st=sico(1,igx,kx)
            ct=sico(2,igx,kx)
            si=sico(3,igx,kx)
            tmpx=hxi*(x-xa)
            ix=tmpx
            sx2=tmpx-float(ix)
            sx1=1.0-sx2
            ix=max0(1,ix+1)
            ix=min0(mxm1,ix)
            do iyp=1,npany
               do igy=1,ngord
                  y=coef(igx,igy,iyp,kx,3)
                  tmpy=hyi*(y-ya)
                  iy=tmpy
                  sy2=tmpy-float(iy)
                  sy1=1.0-sy2
                  iy=max0(1,iy+1)
                  iy=min0(mym1,iy)
                  sp=sy1*(sx1*sigp(ix,iy)+sx2*sigp(ix+1,iy)) +sy2*(sx1*sigp(ix,iy+1)+sx2*sigp(ix+1,iy+1))
                  sh=sy1*(sx1*sigh(ix,iy)+sx2*sigh(ix+1,iy)) +sy2*(sx1*sigh(ix,iy+1)+sx2*sigh(ix+1,iy+1))
                  coef(igx,igy,iyp,kx,5)=st*sp/(si*si)
                  coef(igx,igy,iyp,kx,6)=sh/si
                  coef(igx,igy,iyp,kx,7)=(-coef(igx,igy,iyp,kx,6))
                  coef(igx,igy,iyp,kx,8)=sp/st
               end do
            end do
         end do
      end do
      x=tx(nx+1)
      st=sin(x)
      ct=cos(x)
      si=2.0*ct/sqrt(1.0+3.0*ct*ct)
      kx=1
      igx=1
      tmpx=hxi*(x-xa)
      ix=tmpx
      sx2=tmpx-float(ix)
      sx1=1.0-sx2
      ix=max0(1,ix+1)
      ix=min0(mxm1,ix)
      do iyp=1,npany
         do igy=1,ngord
            y=coef(igx,igy,iyp,kx,3)
            tmpy=hyi*(y-ya)
            iy=tmpy
            sy2=tmpy-float(iy)
            sy1=1.0-sy2
            iy=max0(1,iy+1)
            iy=min0(mym1,iy)
            sh=sy1*(sx1*sigh(ix,iy)+sx2*sigh(ix+1,iy)) +sy2*(sx1*sigh(ix,iy+1)+sx2*sigh(ix+1,iy+1))
            coefr(igy,iyp,1)=sh/si
         end do
      end do
   endif

   if(ijob.eq.2) then
      do kx=1,nx
         do igx=1,ngord
            x=coef(igx,1,1,kx,2)
            st=sico(1,igx,kx)
            ct=sico(2,igx,kx)
            si=sico(3,igx,kx)
            tmpx=hxi*(x-xa)
            ix=tmpx
            sx2=tmpx-float(ix)
            sx1=1.0-sx2
            ix=max0(1,ix+1)
            ix=min0(mxm1,ix)
            do iyp=1,npany
               do igy=1,ngord
                  y=coef(igx,igy,iyp,kx,3)
                  tmpy=hyi*(y-ya)
                  iy=tmpy
                  sy2=tmpy-float(iy)
                  sy1=1.0-sy2
                  iy=max0(1,iy+1)
                  iy=min0(mym1,iy)
                  xj=sy1*(sx1*xjpa(ix,iy)+sx2*xjpa(ix+1,iy)) +sy2*(sx1*xjpa(ix,iy+1)+sx2*xjpa(ix+1,iy+1))
                  coef(igx,igy,iyp,kx,1)=st*si*xj
               end do
            end do
         end do
      end do
   endif

   return
end
! ---------------------------------------------------------------------
subroutine mkgaus(nx,ny,npany,ngord,tx,coef,coefr)
! ---------------------------------------------------------------------
!.... create gauss legendre integration points and weights
   real coef(ngord,ngord,npany,nx,8)
   real coefr(ngord,npany,3)
   real tx(*)
   real gpxx(20),gpyy(20),gpwx(20),gpwy(20)
   parameter (pi=3.1415926)

   do kx=1,nx
      call gauleg(tx(kx),tx(kx+1),gpxx,gpwx,ngord)
      do iyp=1,npany
         ty1=(-pi)+pi*2.0*float(iyp-1)/float(npany)
         ty2=(-pi)+pi*2.0*float(iyp )/float(npany)
         call gauleg(ty1,ty2,gpyy,gpwy,ngord)
         do igy=1,ngord
            coefr(igy,iyp,2)=gpyy(igy)
            coefr(igy,iyp,3)=gpwy(igy)
            do igx=1,ngord
               coef(igx,igy,iyp,kx,2)=gpxx(igx)
               coef(igx,igy,iyp,kx,3)=gpyy(igy)
               coef(igx,igy,iyp,kx,4)=gpwx(igx)*gpwy(igy)
            end do
         end do
      end do
   end do

   return
end

! -------------------------------------------------------------------
subroutine emat(em,tx,kk,nx,ny,ndof,ngord,npany, wk,ijob,coef,coefr)
! -------------------------------------------------------------------
! ..... coefficients etc at gausspoints
! ..... 1: rhs 2: gpx 3: gpy  4: ww 5: stt 6: stp  7: spt  8: spp
   real coef(ngord,ngord,npany,nx,8)
   real coefr(ngord,npany,3)
   real em(ndof+1,ndof)
   real tx(*)
   real wk(2,npany,ngord,2*ny)
   real bb(4),bx(4)
   parameter (pi=3.1415926)

   ny2=2*ny
!.... make table for fourier coeff
   if(ijob.eq.0) then
      do iyp=1,npany
         do igy=1,ngord
            yy=coef(1,igy,iyp,1,3)
            do j=1,ny2
               itmp1=(j-1)/2
               itmp2=mod(j,2)
               tmp1=float(itmp1+itmp2)
               if(itmp2.eq.0) wk(1,iyp,igy,j)=cos(yy*tmp1)
               if(itmp2.eq.1) wk(1,iyp,igy,j)=sin(yy*tmp1)
               itmp1=(j-1)/2
               itmp2=mod(j,2)
               tmp1=float(itmp1+itmp2)
               if(itmp2.eq.0) wk(2,iyp,igy,j)=(-tmp1*sin(yy*tmp1))
               if(itmp2.eq.1) wk(2,iyp,igy,j)= tmp1*cos(yy*tmp1)
            end do
         end do
      end do
   endif

!.... numerically integrate element matrix and rhs



   if(ijob.eq.1) then

      tx1=tx(kk)
      tx2=tx(kk+1)
      do 94711 iyp=1,npany
         do 94712 igy=1,ngord
            do 94713 igx=1,ngord
!..... 1: rhs 2: gpx 3: gpy  4: stt 5: stp  6: spt  7: spp
               ww =coef(igx,igy,iyp,kk,4)
               xx =coef(igx,igy,iyp,kk,2)
               yy =coef(igx,igy,iyp,kk,3)
               acof=coef(igx,igy,iyp,kk,5)*ww
               bcof=coef(igx,igy,iyp,kk,6)*ww
               ccof=coef(igx,igy,iyp,kk,7)*ww
               dcof=coef(igx,igy,iyp,kk,8)*ww
               call hermite(bb,bx,xx,tx1,tx2)


               do 94714 j2=1,ny2
                  f20=wk(1,iyp,igy,j2)
                  f21=wk(2,iyp,igy,j2)
                  do 94714 i2=1,4
                     k2=ny2*(i2-1)+j2
                     tmp1=acof*bx(i2)*f20
                     tmp2=bcof*bx(i2)*f20
                     tmp3=ccof*bb(i2)*f21
                     tmp4=dcof*bb(i2)*f21
                     do 94715 j1=1,ny2
                        tmp5=wk(1,iyp,igy,j1)*(tmp1+tmp3)
                        tmp6=wk(2,iyp,igy,j1)*(tmp2+tmp4)
                        do 94715 i1=1,4
                           k1=ny2*(i1-1)+j1
                           em(k1,k2)=em(k1,k2)+bx(i1)*tmp5+bb(i1)*tmp6
94715                continue
94714          continue


94713       continue
94712    continue
94711 continue

!.... boundary conditions

      if(kk.eq.1) then
         do 94682 i2=2,2
            do 94682 j2=1,2*ny
               k2=ny2*(i2-1)+j2
               do 94682 i1=1,4
                  do 94682 j1=1,2*ny
                     k1=ny2*(i1-1)+j1
                     em(k1,k2)=0.0
                     if(k1.eq.k2)em(k1,k2)=1.0
94682    continue
      endif

      if(kk.eq.nx) then
         do 94683 i2=3,3
            do 94683 j2=1,2*ny
               k2=ny2*(i2-1)+j2
               do 94683 i1=1,4
                  do 94683 j1=1,2*ny
                     k1=ny2*(i1-1)+j1
                     em(k1,k2)=0.0
                     if(k1.eq.k2)em(k1,k2)=1.0
94683    continue
      endif

   endif
   if(ijob.eq.2) then

      tx1=tx(kk)
      tx2=tx(kk+1)
      do 94591 iyp=1,npany
         do 94592 igy=1,ngord
            do 94593 igx=1,ngord
!..... 1: rhs 2: gpx 3: gpy  4: stt 5: stp  6: spt  7: spp
               ww =coef(igx,igy,iyp,kk,4)
               xx =coef(igx,igy,iyp,kk,2)
               yy =coef(igx,igy,iyp,kk,3)
               rrhs=coef(igx,igy,iyp,kk,1)*ww
               call hermite(bb,bx,xx,tx1,tx2)


               do 94594 j2=1,ny2
                  f20=wk(1,iyp,igy,j2)
                  f21=wk(2,iyp,igy,j2)
                  do 94594 i2=1,4
                     k2=ny2*(i2-1)+j2
                     em(ndof+1,k2)=em(ndof+1,k2)-rrhs*bb(i2)*f20
94594          continue


94593       continue
94592    continue
94591 continue

!.... boundary conditions

      if(kk.eq.1) then
         do 94562 i2=2,2
            do 94562 j2=1,2*ny
               k2=ny2*(i2-1)+j2
               em(ndof+1,k2)=0.0
94562    continue
      endif

      if(kk.eq.nx) then
         do 94563 i2=3,3
            do 94563 j2=1,2*ny
               k2=ny2*(i2-1)+j2
               em(ndof+1,k2)=0.0
94563    continue
      endif

   endif

   return
end
! ---------------------------------------------------------------------
subroutine addmat(a,rhs,em,neq,nb,ndof,ny4,k,ijob)
! ---------------------------------------------------------------------
   real a(*),rhs(*),em(ndof+1,ndof)

!.... add element matrix to global array
   if(ijob.eq.1) then
      do j=1,ndof
         if(k.eq.1) then
            iy=j
         else
            iy=ny4*(k-1)+j
         endif
         do i=1,ndof
            if(k.eq.1) then
               ix=i
            else
               ix=ny4*(k-1)+i
            endif
            l=(ix-iy+nb)*neq+iy
            a(l)=a(l)+em(i,j)
         end do
      end do
   endif

!.... compile rhs only
   if(ijob.eq.2) then
      do j=1,ndof
         if(k.eq.1) then
            iy=j
         else
            iy=ny4*(k-1)+j
         endif
         rhs(iy)=rhs(iy)+em(ndof+1,j)
      end do
   endif

   return
end
! ---------------------------------------------------------------------
subroutine xzero(a,n)
! ---------------------------------------------------------------------
   real a(n)
   do i=1,n
      a(i)=0.0
   end do
   return
end
! ---------------------------------------------------------------------
subroutine xcopy(a,b,n)
! ---------------------------------------------------------------------
   real a(n),b(n)
   do i=1,n
      b(i)=a(i)
   end do
   return
end

! -----------------------------------------------------
subroutine hermite(bb,bx,x,x1,x2)
! -----------------------------------------------------
   real bb(4),bx(4)
!
!.... hermite polys have:
!                H(1,x1) = 1
!           d/dx/H(2,x1) = 1
!                H(3,x2) = 1
!           d/dx H(4,x2) = 1
!... makes global numbering a lot easier
   z=x-x1
   h=x2-x1
   rh=1.0/h
   s=z*rh
   bb(1) = s*s*(2.0*s-3.0)+1.0
   bb(3) = s*s*(3.0-2.0*s)
   bb(2) = s*(1.0-s)*(h-z)
   bb(4) = s*z*(s-1.0)
   bx(1) = 6.0*(s-1.0)*rh*s
   bx(3) = 6.0*(1.0-s)*rh*s
   bx(2) = (1.0-s)*(1.0-3.0*s)
   bx(4) = s*(3.0*s-2.0)

   return
end
!-------------------------------------------------
subroutine gauleg(x1,x2,x,w,n)
!-------------------------------------------------

   real x1,x2,x(n),w(n)

   parameter (pi=3.1415926)

   eps=1.0e-6

   m=(n+1)/2
   xm=0.5*(x2+x1)
   xl=0.5*(x2-x1)
   do 12 i=1,m
      z=cos(pi*(i-.25)/(n+.5))
      nrep=0
1     continue
      nrep=nrep+1
      p1=1.0
      p2=0.0
      do 11 j=1,n
         p3=p2
         p2=p1
         p1=((2.0*j-1.0)*z*p2-(j-1.0)*p3)/j
11    continue
      pp=n*(z*p1-p2)/(z*z-1.0)
      z1=z
      z=z1-p1/pp
      if(abs(z-z1).gt.eps.and.nrep.le.100)go to 1
      x(i)=xm-xl*z
      x(n+1-i)=xm+xl*z
      w(i)=2.0*xl/((1.0-z*z)*pp*pp)
      w(n+1-i)=w(i)
12 continue
   return
end
! ---------------------------------------------------------------
subroutine leqt1b (a,n,nlc,nuc,ia,b,m,ib,ijob,xl,ier)
! --------------------------------------------------------------
   real a(ia,*),xl(n,*),b(ib,*)
   data zero/0./,one/1.0/
   ier = 0
   jbeg = nlc+1
   nlc1 = jbeg
   if (ijob .eq. 2) go to 80
   rn = n
   i = 1
   nc = jbeg+nuc
   nn = nc
   jend = nc
   if (n .eq. 1 .or. nlc .eq. 0) go to 25
5  k = 1
   p = zero
   do j = jbeg,jend
      a(i,k) = a(i,j)
      q = abs(a(i,k))
      if (q .gt. p) p = q
      k = k+1
   end do
   if (p .eq. zero) go to 135
   xl(i,nlc1) = one/p
   if (k .gt. nc) go to 20
   do j = k,nc
      a(i,j) = zero
   end do
20 i = i+1
   jbeg = jbeg-1
   if (jend-jbeg .eq. n) jend = jend-1
   if (i .le. nlc) go to 5
   jbeg = i
   nn = jend
25 jend = n-nuc
   do i = jbeg,n
      p = zero
      do j = 1,nn
         q = abs(a(i,j))
         if (q .gt. p) p = q
      end do
      if (p .eq. zero) go to 135
      xl(i,nlc1) = one/p
      if (i .eq. jend) go to 37
      if (i .lt. jend) cycle
      k = nn+1
      do j = k,nc
         a(i,j) = zero
      end do
37    nn = nn-1
   end do
   l = nlc
   do 75 k = 1,n
      p = abs(a(k,1))*xl(k,nlc1)
      i = k
      if (l .lt. n) l = l+1
      k1 = k+1
      if (k1 .gt. l) go to 50
      do j = k1,l
         q = abs(a(j,1))*xl(j,nlc1)
         if (q .le. p) cycle
         p = q
         i = j
      end do
50    xl(i,nlc1) = xl(k,nlc1)
      xl(k,nlc1) = i
      q = rn+p
      if (q .eq. rn) go to 135
      if (k .eq. i) go to 60
      do j = 1,nc
         p = a(k,j)
         a(k,j) = a(i,j)
         a(i,j) = p
      end do
60    if (k1 .gt. l) go to 75
      do 70 i = k1,l
         p = a(i,1)/a(k,1)
         ik = i-k
         xl(k1,ik) = p
         if(p.eq.0.0) then
            do j = 2,nc
               a(i,j-1) = a(i,j)
            end do
         else
            do j = 2,nc
               a(i,j-1) = a(i,j)-p*a(k,j)
            end do
         endif
         a(i,nc) = zero
70    continue
75 continue
   if (ijob .eq. 1) go to 9005
80 l = nlc
   do 105 k = 1,n
      i = xl(k,nlc1)
      if (i .eq. k) go to 90
      do j = 1,m
         p = b(k,j)
         b(k,j) = b(i,j)
         b(i,j) = p
      end do
90    if (l .lt. n) l = l+1
      k1 = k+1
      if (k1 .gt. l) go to 105
      do 100 i = k1,l
         ik = i-k
         p = xl(k1,ik)
         if(p.ne.0.0) then
            do j = 1,m
               b(i,j) = b(i,j)-p*b(k,j)
            end do
         endif
100   continue
105 continue
   jbeg = nuc+nlc
   do j = 1,m
      l = 1
      k1 = n+1
      do i = 1,n
         k = k1-i
         p = b(k,j)
         if (l .eq. 1) go to 115
         do kk = 2,l
            ik = kk+k
            p = p-a(k,kk)*b(ik-1,j)
         end do
115      b(k,j) = p/a(k,1)
         if (l .le. jbeg) l = l+1
      end do
   end do
   go to 9005
135 ier = 129
9000 continue
9005 return
end

subroutine inquire_next(found_field,iu,ndim,nx,ny,nz,it,varname,tstring)
  ! read the 'meta-data' from the next field in the file
  ! This will leave the file one field beyond where it was before
  ! called from python as:
  !
  ! was_found,ndim,nx,ny,nz,it = inquire_next(unit,vname,tstring)
  !
  IMPLICIT NONE
  integer :: iu
  !f2py intent(in) iu
  character(Len=80) :: varname,tstring,buff
  !f2py intent(inout) varname,tstring
  integer :: ndim,nx,ny,nz,it
  !f2py intent(out) ndim,nx,ny,nz,it
  integer :: found_field
  !f2py intent(out) found_field

  nx=-1;ny=-1;nz=-1;
  ndim=0
  found_field=0

  do while(.true.)
     read(IU,'(A)',end=888,err=888) buff
     if(buff.eq.'FIELD-1D-1')then
        found_field=1
        ndim=1
        read(IU,'(A)') varname
        read(IU,'(A)') tstring
        read(IU,*)it,nx
        exit
     elseif(buff.eq.'FIELD-2D-1')then
        found_field=1
        ndim=2
        read(IU,'(A)') varname
        read(IU,'(A)') tstring
        read(IU,*)it,nx,ny
        exit
     elseif(buff.eq.'FIELD-3D-1')then
        found_field=1
        ndim=3
        read(IU,'(A)') varname
        read(IU,'(A)') tstring
        read(IU,*)it,nx,ny,nz
        exit
     endif
  enddo
  !Get back to the beginning of this field
  backspace(IU)
  backspace(IU)
  backspace(IU)
  backspace(IU)
888 continue

  !  print*,ndim,nx,ny,nz,it,varname,tstring

end subroutine inquire_next

!----------------------------------------------------------------
subroutine read_jrrle1d(iu,a1,nx,l1,read_ascii,success)
  !----------------------------------------------------------------
  IMPLICIT NONE
  integer iu
  !f2py intent(in) iu
  integer nx
  !f2py intent(hidden) nx
  real a1(nx)
  !f2py intent(inplace) a1
  character(len=*) :: l1
  !f2py intent(inplace) l1
  logical read_ascii
  !f2py intent(in) read_ascii
  integer success
  !f2py intent(out) success

  !locals
  integer i
  integer it
  integer m
  real rid
  integer nn
  character*80 rec

  nn = nx
  rid=0.0
  if((iu.lt.0).or.(iu.gt.32768))then
     write(0,*)'Exception: Ambiguous I/O unit number.'
     return
  endif
  success=0
  !==============================================
  m=LEN(l1)
  call end0(l1,m)
100 continue
  read(iu,1000,end=190,err=190) rec
  if(rec(1:10).eq.'FIELD-1D-1') then
     read(iu,1000,end=190) rec
     if((l1(1:m).ne.rec(1:m))) goto 100
     l1=rec
     read(iu,1000,end=190) rec
     read(iu,*,end=190)it,nn
     call rdn2(iu,a1,nn,rec,it,rid)

     ! see if we have fullascii
     if (read_ascii .or. nn.ne.nx) then
       read(iu,'(a)')rec
       if(rec(2:17).eq.'fullasciifollows') then
         ! write(0,*)'reading:  ',rec(2:17)
         do i=1,nx; read(iu,*)a1(i); enddo
       else
         backspace(iu)
       endif
     endif

     if(nn.eq.nx)then
        success = 1
     endif
     return
  endif
  goto 100
190 continue
  success=0

1000 format(A)
  return
end subroutine read_jrrle1d

!----------------------------------------------------------------
subroutine read_jrrle2d(iu,a1,nx,l1,read_ascii,success)
  !----------------------------------------------------------------
  IMPLICIT NONE
  integer iu
  !f2py intent(in) iu
  integer nx !Total Number of points.  (note this is slightly different than getf21)
  !f2py intent(hidden) nx
  real a1(nx)
  !f2py intent(inplace) a1
  character(len=*) :: l1
  !f2py intent(inplace) l1
  logical read_ascii
  !f2py intent(in) read_ascii
  integer success
  !f2py intent(out) success

  !locals
  integer i
  integer it
  integer m
  real rid
  integer nn,nx1,ny1
  character*80 rec

  nn = nx
  rid=0.0
  if((iu.lt.0).or.(iu.gt.32768))then
     write(0,*)'Exception: Ambiguous I/O unit number.'
     return
  endif
  success=0
  !==============================================
  m=LEN(l1)
  call end0(l1,m)
100 continue
  read(iu,1000,end=190,err=190) rec
  if(rec(1:10).eq.'FIELD-2D-1') then
     read(iu,1000,end=190) rec
     if((l1(1:m).ne.rec(1:m))) goto 100
     l1=rec
     read(iu,1000,end=190) rec
     read(iu,*,end=190)it,nx1,ny1
     call rdn2(iu,a1,nn,rec,it,rid)

    ! see if we have fullascii
    if (read_ascii .or. nn.ne.nx) then
      read(iu,'(a)')rec
      if(rec(2:17).eq.'fullasciifollows') then
        ! write(0,*)'reading:  ',rec(2:17)
        do i=1,nx; read(iu,*)a1(i); enddo
      else
        backspace(iu)
      endif
    endif

    if(nx1*ny1.eq.nx)then
      success = 1
    endif
    return
  endif
  goto 100

190 continue
  success=0

1000 format(A)
  return
end subroutine read_jrrle2d

!----------------------------------------------------------------
subroutine read_jrrle3d(iu,a1,nx,l1,read_ascii,success)
  !----------------------------------------------------------------
  IMPLICIT NONE
  integer iu
  !f2py intent(in) iu
  integer nx
  !f2py intent(hidden) nx
  real a1(nx)
  !f2py intent(inplace) a1
  character(len=*) :: l1
  !f2py intent(inplace) l1
  logical read_ascii
  !f2py intent(in) read_ascii
  integer success
  !f2py intent(out) success

  !locals
  integer i
  integer it
  integer m
  real rid
  integer nn,nx1,ny1,nz1
  character*80 rec

  nn = nx
  rid=0.0
  if((iu.lt.0).or.(iu.gt.32768))then
     write(0,*)'Exception: Ambiguous I/O unit number.'
     return
  endif
  success=0
  !==============================================
  m=LEN(l1)
  call end0(l1,m)
100 continue
  read(iu,1000,end=190,err=190) rec
  if(rec(1:10).eq.'FIELD-3D-1') then
     read(iu,1000,end=190) rec
     if((l1(1:m).ne.rec(1:m))) goto 100
     l1=rec
     read(iu,1000,end=190) rec
     read(iu,*,end=190)it,nx1,ny1,nz1
     call rdn2(iu,a1,nn,rec,it,rid)

     ! see if we have fullascii
     if (read_ascii .or. nn.ne.nx) then
       read(iu,'(a)')rec
         if(rec(2:17).eq.'fullasciifollows') then
         ! write(0,*)'reading:  ',rec(2:17)
         do i=1,nx; read(iu,*)a1(i); enddo
       else
         backspace(iu)
       endif
     endif

     if((nx1*ny1*nz1.eq.nx))then
        success = 1
     endif
     return
  endif
  goto 100
190 continue
  success=0

1000 format(A)
  return
end subroutine read_jrrle3d


!-----------------------------------------------------------
subroutine write_jrrle1d(iu,a1,nx,l1,l2,it)
  !-----------------------------------------------------------
  IMPLICIT NONE
  integer iu                !io unit
  !f2py intent(in) iu
  character*80 l1,l2        !l1 variable name, l2: ascii time string
  !f2py intent(in) l1,l2
  real a1(nx)                !array to write
  !f2py intent(in) a1
  integer nx,it             !nx: dimension of array, it: integer time
  !f2py intent(in) nx,it

  write(iu,'(a)')'FIELD-1D-1'
  write(iu,'(a)') l1
  write(iu,'(a)') l2
  write(iu,*) it,nx
  call wrn2(iu,a1,nx,'FUNC-1-1',it,float(it))
  return
end subroutine write_jrrle1d

!-----------------------------------------------------------
subroutine write_jrrle2d(iu,a1,nx,ny,l1,l2,it)
!-----------------------------------------------------------
  IMPLICIT NONE
  integer iu                !io unit
  !f2py intent(in) iu
  character*80 l1,l2        !l1 variable name, l2: ascii time string
  !f2py intent(in) l1,l2
  real a1(nx*ny)                !array to write
  !f2py intent(in) a1
  integer nx,ny,it          !nx: dimension of array, it: integer time
  !f2py intent(in) nx,ny,it

  write(iu,'(a)')'FIELD-2D-1'
  write(iu,'(a)') l1
  write(iu,'(a)') l2
  write(iu,*)it,nx,ny
  call wrn2(iu,a1,nx*ny,'FUNC-2-1',it,float(ny))
  return
end subroutine write_jrrle2d

!-----------------------------------------------------------
subroutine write_jrrle3d(iu,a1,nx,ny,nz,l1,l2,it)
!-----------------------------------------------------------
  IMPLICIT NONE
  integer iu                !io unit
  !f2py intent(in) iu
  character*80 l1,l2        !l1 variable name, l2: ascii time string
  !f2py intent(in) l1,l2
  real a1(nx*ny*nz)                !array to write
  !f2py intent(in) a1
  integer nx,ny,nz,it          !nx: dimension of array, it: integer time
  !f2py intent(in) nx,ny,nz,it

  write(iu,'(a)')'FIELD-3D-1'
  write(iu,'(a)') l1
  write(iu,'(a)') l2
  write(iu,*)it,nx,ny,nz
  call wrn2(iu,a1,nx*ny*nz,'FUNC-3-1',it,float(ny))
  return
end subroutine write_jrrle3d

!!!!!!!!!!! These routines probably don't need to be converted to python !!!!!!!!!!!

!-----------------------------------------------------------
subroutine end0(r,m)
  !
  ! find the end of a string (ie first white space)
  !
  ! assumes strings are space padded and that 80 is the
  ! maximum length.
  !
  !-----------------------------------------------------------
  IMPLICIT NONE
  integer i,n,m
  character*80 r

  ! presumably m is a reasonable value to begin with...
  n = min0(m,len(r))

  ! find first space in string, return index just prior
  do i = 1,n
     m = i - 1
     if ( r(i:i).eq.' ' ) return
  enddo

  ! or return the smaller of the array length and
  ! 80 if no spaces are encountered
  m=n

  return

end subroutine end0

! Change log---
!
! Burlen Loring 2008-01-03
!
! added comments, indetantion, and implicit none
!.---------------------------------------
subroutine rdn2( fileNo,a,n,cid,it,rid )
  !
  !
  !
  ! character decoding
  !.---------------------------------------
  real a(n)
  integer n
  integer it
  real rid
  character*8 cid
  character*4 did
  character*8 nid
  real a1(0:63)
  integer intRec1(0:63),intRec2(0:63),i3(0:63)
  integer q
  integer fileNo

  read( UNIT=fileNo,FMT='(a4,a8,3e14.7,i8,a)',ERR=100,END=900 ) &
       did,nid,zmin,zmax,rid,it,cid
  ! The format of the header record is as follows:
  ! 1, 4 char string                                    ( did )
  ! 8 chars to 1 int                                    ( n )
  ! 3 times 14 chars to double w/ 7 digits precision    ( zmin,zmax,rid )
  ! 8 chars to 1 int                                    ( it )
  ! 1, 8 char string                                    ( cid )

  ! if nid is "********" then the number of grid cells is too large for
  ! the jrrle format, so we need to assume that the value passed in as
  ! `n` is correct, or else all is lost
  if (nid.ne."********") then
    read(nid,'(i8)') nid_asint
    if (nid_asint.ne.n) then
      write(0,*)'rdn2: nid (nid_asint) .ne. n ', nid, nid_asint, n
    endif
    n = nid_asint
  endif

  ! try read again, if we don't have WRN2 data
  if( did.ne.'WRN2' ) then
     goto 100
  endif

  ! data array is constant, initialize a and return
  if(zmin.eq.zmax) then
     do i=1,n
        a(i)=zmin
     enddo
     return
     ! compute data resolution
  else
     ! what is the significance of 4410??
     ! and why the explicit cast rather than 4410.0??
     dzi=(zmax-zmin)/float(4410)
  endif

  ! process data records, these are 64 characters long
  q=0 ! index into decompressed real*8 data
  do k=1,n,64

     ! records should be 64 ints long but last one may be shorter
     nk = min0(63,n-k)

     ! decompress a record( expands and converts ascii to hex)
     call wrndec(fileNo,intRec1,nn)

     ! error in record length bail
     ! note: if returned nn=-5 explicitly indicates an error
     if(nn.ne.nk) then
        write(0,*)'rdn2: nn .ne. nk ',nn,nk,n,k
        n=-2
        return
     endif

     ! decompress next record( expands and converts ascii to hex)
     call wrndec(fileNo,intRec2,nn)

     ! error in record length bail
     ! note: if returned nn=-5 explicitly indicates an error
     if(nn.ne.nk) then
        write(0,*)'rdn2: nn .ne. nk ',nn,nk
        n=-2
        return
     endif

     ! convert these records from hex-ascii to double
     ! not sure about the specifics here except that
     ! this is the propritary OpenGGCM format
     ! what is significance of 33,47 and 94 ??
     do i=0,nk
        intRec1(i) = intRec1(i) - 33
        intRec2(i) = intRec2(i) - 33
        sig        = 1.

        if( intRec1(i).ge.47 ) then
           sig        = -1.
           intRec1(i) = intRec1(i) - 47
        endif

        i3(i) = intRec2(i) + 94*intRec1(i)
        a1(i) = FLOAT(i3(i))
        a1(i) = dzi*a1(i) + zmin
        a1(i) = sig*exp(a1(i))

        q    = q + 1
        a(q) = a1(i)
     enddo
  enddo

  return

  ! there was no rle data (ascii only?)
100 continue
  n=-1
  backspace(fileNo)
  return

  ! io error occurred
900 continue
  n=-1
  return
end subroutine rdn2


!---------------------------------------
subroutine wrndec(fileNo,expandedDatOut,n)
  !
  ! decode compressed data sequence read in from a file
  ! will decode a single record (typically 64 chars ion length)
  !
  ! the decompressed record is returned in exdpandedDataOut
  ! the length of the de-compressed record is returned in n
  ! n=-5 indicates something bad happened
  !
  !.---------------------------------------
  IMPLICIT NONE
  integer fileNo
  integer n
  integer nRep,hexChar
  integer checkSum
  integer i,j,q
  integer expandedDatOut(0:63) ! results returned
  integer expandedDat(-2:67)   ! work array has expanded data + check sum
  character*72 asciiDat        ! read buffer

  ! initialize some of the variables
  ! note: read buffer is space padded, spaces indicate end of field
  n=-5
  expandedDatOut(0)=0
  asciiDat='                                                                        '

  ! read 72 characters from file(record assumed to be 64 chars)
  read( UNIT=fileNo,FMT='(A)',END=900,ERR=900 ) asciiDat


  ! expand sequences in buffer. An ascii value with 7th bit set
  ! is a count(2^7=128), this tells how many times following ascii
  ! char is repeated. If the 7th bit is not set then the ascii char
  ! appears once.
  ! this is an infinite loop which breaks once a space is encountered
  ! or too many chars have been processed (ie record length exceeded).
  i=-2 ! index into expanded data
  j=0  ! index into read buffer
100 continue
  j = j + 1

  ! error records should not be this long, bail
  if(j.gt.67) then
     write(0,*)'wrndec: cannot find end of encoded record'
     n=-5
     return
  endif

  ! convert j-th value from ascii to hex
  hexChar=ICHAR( asciiDat(j:j) )

  ! if its a space then we are done expanding this record, break
  if ( hexChar.eq.32 ) then
     goto 190
  endif

  ! if its not an 7 bit ascii character
  ! then it tells how many time to repeat the following ascii char
  if ( hexChar.gt.127 ) then

     nRep = hexChar-170 ! convert to count ??

     ! convert next j-th value from ascii to hex
     ! this is repeated nRep times
     j  = j + 1
     hexChar = ICHAR( asciiDat(j:j) )
     do q=1,nRep
        i = i + 1
        expandedDat(i) = hexChar
     enddo

     ! otherwise it is 7 bit ascii, and appears only once
  else
     i = i + 1
     expandedDat(i) = hexChar
  endif

  ! expand next sequence in buffer
  goto 100

190 continue

  ! error we expect field to be 64 chars if its more then this
  ! there is a problem, bail
  n=i
  if( n.gt.63 ) then
     write(0,*)'wrndec: n gt 63, n=',n
     n=-5
     write(0,'(a)')'rec:'
     write(0,'(a)')asciiDat
     return
  endif

  ! copy and compute check sum
  checkSum=0
  do i=0,n
     ! copy
     expandedDatOut(i) = expandedDat(i)
     ! compute check sum
     checkSum = checkSum + expandedDatOut(i)
  enddo

  ! check sum error bail
  if(expandedDat(-1).ne.33+mod(checkSum,92)) then
     write(0,*)'wrndec: checksum error '
     write(0,'(a,a)')'rec:',asciiDat
     write(0,*)expandedDat(-1),33+mod(checkSum,92)
     n=-5
     return
  endif

  return

  ! file io error
900 continue
  write(0,*)' wrndec eof/err '
  n=-5
  return

end subroutine wrndec


!.---------------------------------------
subroutine wrn2(iu,a,n,cid,it,rid)
  !.---------------------------------------
  IMPLICIT NONE
  integer n
  integer it
  integer iu
  real z0
  real a(n)
  real b
  real zmin,zmax
  real z1,z2
  real dz
  real rid
  character*8 cid
  real a1(0:63)
  integer nk
  integer k,i
  integer i1(0:63),i2(0:63),i3(0:63)
  zmin=1.e33
  zmax=1.e-33
  do i=1,n
     b=abs(a(i))
     zmin=amin1(zmin,b)
     zmax=amax1(zmax,b)
  enddo
  zmin=amax1(1.e-33,zmin)
  zmax=amin1( 1.e33,zmax)
  z2=alog(zmax)
  z1=-76.
  if(zmin.ne.0.)then
     z1=alog(zmin)
  endif
  z1=amax1(z1,z2-37.)
  if(abs(z2-z1).le.1.e-5)then
     z1=z1-1.0
     z2=z2+1.0
  endif
  z0=exp(z1)
  dz=float(4410)/(z2-z1)
1000 format(a,i8,3e14.7,i8,a)
  write(iu,1000)'WRN2',n,z1,z2,rid,it,cid
  do k=1,n,64
     nk=min0(63,n-k)
     do i=0,nk
        a1(i)=amin1(1.e33,abs(a(i+k)))
        a1(i)=amax1(z0,a1(i))
        a1(i)=dz*(alog(a1(i))-z1)+0.5
        i3(i)=INT(a1(i))
        i3(i)=max0(0,i3(i))
        i3(i)=min0(4414,i3(i))
        i1(i)=i3(i)/94
        i2(i)=i3(i)-94*i1(i)
        if(a(i+k).lt.0.)then
           i1(i)=i1(i)+47
        endif
        i1(i)=i1(i)+33
        i2(i)=i2(i)+33
     enddo
     call wrnenc(iu,i1,nk)
     call wrnenc(iu,i2,nk)
  enddo
  return
end subroutine wrn2


!.---------------------------------------
subroutine wrnenc(iu,i1,n)
  !.---------------------------------------
  integer iu
  integer n
  integer i1(0:63)
  integer i2(-1:63)
  character c*72
  ick=i1(0)
  ir=i1(0)
  ic=1
  k=-1
  do i=1,n
     ick=ick+i1(i)
     if(i1(i).eq.ir) then
        ic=ic+1
     else
        if(ic.eq.1) then
           k=k+1
           i2(k)=ir
        else
           k=k+1
           i2(k)=ic+170
           k=k+1
           i2(k)=ir
        endif
        ic=1
        ir=i1(i)
     endif
  enddo
  if(ic.eq.1) then
     k=k+1
     i2(k)=ir
  else
     k=k+1
     i2(k)=ic+170
     k=k+1
     i2(k)=ir
  endif
  i2(-1)=33+mod(ick,92)
  j=0
  do i=-1,k
     j=j+1
     c(j:j)=char(i2(i))
  enddo
  write(iu,'(a)')c(1:j)
  return
end subroutine wrnenc

!This module contains (pure) f90 code in free-format with modules.
!There is no fppn necessary to compile it. For the sake of future
!projects, it might be nice to keep it that way :-) -- MLG
!
!As such, it needs to be
!compiled BEFORE any other code which uses it.  It has no dependencies,
!so there is no harm in compiling it first.

!doc -
!doc - These modules contains stuff originally in mhd-cotr.for
!doc -
!doc - Original AUTHOR:
!doc -           Joachim Raeder, IGPP/UCLA, June 1994
!doc - The new modules are updated to minimize global data
!doc - and to use some of the neater features of fortran90
!doc -
!doc - Updating AUTHOR:
!doc -           Matthew L Gilson, SSC/UNH, January 2013


module date_lib

   integer,private,parameter,dimension(12,2) :: mdays = RESHAPE( &
         (/0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, &
         0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335/), &
         (/12,2/))


contains
! ----------------------------------------------------------------
   subroutine epoch1966(dsecs,iy,mo,id,ih,mi,sec,iimod)
! ----------------------------------------------------------------
      !cdoc-
      !cdoc-FUNCTION:
      !cdoc-  converts seconds since JAN 1, 1966 0UT to year,month,day,hour,
      !cdoc-  minute and second or vice versa
      !cdoc-
      !cdoc-PARAMETERS:
      !cdoc-  dsec (in/out): seconds of epoch 1966
      !cdoc-  iy,mo,id,ih,mi,se (in):  time in UT
      !cdoc-  iimod (in,integer): flag
      !cdoc-                     iimod=0: convert iy,... to dsec
      !cdoc-                     iimod!=0: convert dsec to iy,...
      !cdoc-
      !cdoc-NOTE:
      !cdoc-  works only for times after JAN 1, 1966, i.e. dsec positive
      !cdoc-
      implicit none

      integer iy,mo,id,ih,mi,iimod
      real*8 dsecs
      real sec

      integer i,ij,jj
      real*8 ss,ds,dso
      integer,parameter,dimension(0:11) :: rdays= (/ 31,28,31,30,31,30,31,31,30,31,30,31 /)
      integer,parameter,dimension(0:11) :: jdays = (/ 31,29,31,30,31,30,31,31,30,31,30,31 /)

      if(iimod.eq.0) then
         jj=iy
         if(jj.lt.100)jj=jj+1900
         ss=0.0
         do i=1966,jj-1
            if(mod(i,4).eq.0) ss=ss+366.0d0*24.0d0*3600.0d0
            if(mod(i,4).ne.0) ss=ss+365.0d0*24.0d0*3600.0d0
         end do
         do i=1,mo-1
            if( mod(jj,4).eq.0 ) ss=ss+dble(jdays(i-1))*24.0d0*3600.0d0
            if( mod(jj,4).ne.0 ) ss=ss+dble(rdays(i-1))*24.0d0*3600.0d0
         end do
         ss=ss+dble(id-1)*3600.0d0*24.0d0
         ss=ss+dble(ih)*3600.0d0
         ss=ss+dble(mi)*60.0d0
         ss=ss+dble(sec)
         dsecs=ss
      else
         ss=dsecs
         ds=0.0d0
         dso=0.0d0
         jj=1966
         do i=0,100
            if(mod(jj,4).eq.0) then
               ds=ds+(366.0d0*24.0d0*3600.0d0)
            else
               ds=ds+(365.0d0*24.0d0*3600.0d0)
            endif
            if(ds.gt.ss) exit
            dso=ds
            jj=jj+1
         end do

         ss=ss-dso
         iy=jj-1900
         ij=0
         if(mod(jj,4).eq.0)ij=1
         ds=0.0d0
         dso=0.0d0
         jj=0
         do i=0,11
            if(ij.eq.0) then
               ds=ds+dble(rdays(i))*24.0d0*3600.0d0
            else
               ds=ds+dble(jdays(i))*24.0d0*3600.0d0
            endif
            if(ds.gt.ss) exit
            dso=ds
            jj=jj+1
         end do

         ss=ss-dso
         mo=jj+1
         ds=ss/(24.0d0*3600.0d0)
         id=int(ds)
         ss=ss-dble(id)*24.0d0*3600.0d0
         id=id+1
         ds=ss/3600.0d0
         ih=int(ds)
         ss=ss-dble(ih)*3600.0d0
         ds=ss/60.0d0
         mi=int(ds)
         ss=ss-dble(mi)*60.0d0
         sec=ss
      endif

      return
   end subroutine epoch1966

!---------------------------------------------------------------
   real*8 function djul(iy,mo,id,ih,mi,se)
!---------------------------------------------------------------
      !cdoc-
      !cdoc-FUNCTION:
      !cdoc-  converts time to fractional julian days
      !cdoc-
      !cdoc-PARAMETERS:
      !cdoc-  iy,mo,id,ih,mi,se (in):  time in UT
      !cdoc-  djul (out,real*8):   fractional julian day
      !cdoc-
      !cdoc-NOTE:
      !cdoc-  expected to work for any time after 4500 BC
      !cdoc-
      implicit none

      integer iy,mo,id,ih,mi
      real*4 se

      integer jy
      integer i1,i2,i3,i4,ier
      real*8 d1,zero,one,xjd,uthour
      parameter(zero=0.0d0,one=1.0d0)
      jy=iy
      if(jy.lt.100)jy=jy+1900
      ier=0
      if(jy.lt.1901) ier=1
      if(jy.gt.2049) ier=7
      if(mo.lt.1.or.mo.gt.12) ier=2
      if(id.lt.1.or.id.gt.31) ier=3
      if(ih.lt.0.or.ih.gt.23) ier=4
      if(mi.lt.0.or.mi.gt.63) ier=5
!      if(se.lt.0.0.or.se.gt.60.0) ier=6
      if(ier.ne.0) then
         write(0,*)'error djul, ier= ',ier
!      stop
      endif
      uthour=dble(float(ih))+(dble(float(mi))/60.0d0)+dble(se)/3600.0d0
      i1=367*jy
      i2=(mo+9)/12
      i2=(i2+jy)*7
      i2=i2/4
      i3=(275*mo)/9
      i4=100*jy+mo
      d1=one
      if((dble(i4)-190002.5d0).lt.zero)d1=(-d1)
      xjd=dble(i1) - dble(i2) + dble(i3) + dble(id) + 1721013.5d0 &
            + uthour/24.0d0 - 0.5d0*d1 + 0.5
      djul=xjd
      return
   end function djul

!----------------------------------------------------
   integer function julday(iy,mo,id)
!----------------------------------------------------
      !cdoc-
      !cdoc-FUNCTION:
      !cdoc-  convert date from day - month system to julian day system
      !cdoc-
      !cdoc-PARAMETERS:
      !cdoc-  iy (in,integer):  year (nn or nnnn notation)
      !cdoc-  mo (in,integer): month
      !cdoc-  id (in,integer): day of month
      !cdoc-  julday (out,integer): julian day of year
      !cdoc-
      implicit none

      integer iy,mo,id
      integer leap,jmo

      jmo=max0(1,min0(12,mo))
      leap=1
      if(mod(iy,4).eq.0)leap=2
      julday=mdays(jmo,leap)+id
      return
   end function julday


!----------------------------------------------------
   subroutine daymon(iy,jd,mo,id)
!----------------------------------------------------
      !cdoc-
      !cdoc-FUNCTION:
      !cdoc-  convert date from julian day system to day - month system
      !cdoc-
      !cdoc-PARAMETERS:
      !cdoc-  iy (in,integer):  year (nn or nnnn notation)
      !cdoc-  jd (in,integer):  julian day (1<=jd<=366), january 1 <> jd=1
      !cdoc-  mo (out,integer): month
      !cdoc-  id (out,integer): day of month
      !cdoc-
      implicit none

      integer iy,jd,mo,id
      integer leap,i,k

      leap=1
      if(mod(iy,4).eq.0)leap=2
      k=1
      do i=1,12
         if(jd.le.mdays(i,leap)) exit
         k=i
      end do

      mo=k
      id=jd-mdays(k,leap)
      return
   end subroutine daymon

end module date_lib

! ================================================================

module new_cotr

   real*8,parameter,private :: rad=17.45329252d-3
   real*8,parameter,private :: deg=57.29577951d0


   type transform
      integer :: iscalled
      integer :: icalled = 1
      real*8,dimension(3,3,2) :: tmpmat
      real*8,dimension(3,3) :: cmat
      real*8,dimension(3,3,-7:7) :: pmat
      real*8 :: t0
      integer :: year,month,day,hour,minute
      real :: seconds
      character(len=4) :: ccfr,ccto
   end type transform

   interface cotr_set
      module procedure cotr_set_1  !transform from explicit times
      module procedure cotr_set_r8 !transform from r*8 time
   end interface cotr_set

   interface diptil
      module procedure diptil_1
      module procedure diptil_tran
   end interface diptil

contains

   function transform_2_r8(tran)
      use date_lib
      implicit none
      type(transform),intent(IN) :: tran
      real*8 :: transform_2_r8
      call epoch1966(transform_2_r8, &
            tran%year,tran%month,tran%day, &
            tran%hour,tran%minute,tran%seconds,0)
      return
   end function transform_2_r8


!----------------------------------------------------
   subroutine xyzdeg(x,y,z,r,p,t)
!----------------------------------------------------
!doc-
!doc-FUNCTION:
!doc-  convert from cartesian to polar coordinates, angles in degrees
!doc-
!doc-PARAMETERS:
!doc-  x,y,z (in,real): cartesian coordinates
!doc-  r,p,t (out,real): polar coordinates,
!doc-                    -180.0<=p<=180.0, 0<=t<=180.0
!doc-                    i.e. colatitude system
!doc-
      implicit none
      real x,y,z,r,p,t
      r=sqrt(x*x+y*y+z*z)
      p=0.0
      if(abs(x)+abs(y).gt.0.0)p=deg*atan2(y,x)
      t=0.0
      if(r.gt.0.0)t=deg*acos(z/r)
      return
   end subroutine xyzdeg

!----------------------------------------------------
   subroutine radxyz(r,p,t,x,y,z)
!----------------------------------------------------
!doc-
!doc-FUNCTION:
!doc-  convert from polar coordinates (angles in radian) to cartesian
!doc-
!doc-CALL SEQUENCE:
!doc-
!doc-PARAMETERS:
!doc-  r,p,t (in,real): polar coordinates, -pi<=p<=pi, 0<=t<=pi
!doc-                    i.e. colatitude system
!doc-  x,y,z (out,real): cartesian coordinates
!doc-
      implicit none

      real r,p,t,x,y,z

      real st

      st=sin(t)
      x=r*cos(p)*st
      y=r*sin(p)*st
      z=r*cos(t)
      return
   end subroutine radxyz

!----------------------------------------------------
   subroutine degxyz(r,p,t,x,y,z)
!----------------------------------------------------
!doc-
!doc-FUNCTION:
!doc-  convert from polar coordinates (angles in degrees) to cartesian
!doc-
!doc-PARAMETERS:
!doc-  r,p,t (in,real): polar coordinates,
!doc-                    -180.0<=p<=180.0, 0<=t<=180.0
!doc-                    i.e. colatitude system
!doc-  x,y,z (out,real): cartesian coordinates
!doc-
      implicit none

      real r,p,t,x,y,z
      real pp,tt,st

      pp=p*rad
      tt=t*rad
      st=sin(tt)
      x=r*cos(pp)*st
      y=r*sin(pp)*st
      z=r*cos(tt)
      return
   end subroutine degxyz


!----------------------------------------------------
   subroutine cotr(tran,cfr,cto,x1,y1,z1,x2,y2,z2)
!----------------------------------------------------
!     doc-
!     doc-FUNCTION:
!     doc-  transform vector (x1,y1,z1) in coordinate system 'cfr'
!     doc-  to vector (x2,y2,z2) in coordinate system 'cto'
!     doc-  coordinate systems 'cfr' and 'cto' can be any of the following:
!     doc-  'gei'  :  geocentric equatorial inertial
!     doc-  'geo'  :  geographic
!     doc-  'gse'  :  geocentric solar ecliptic
!     doc-  'gsm'  :  geocentric solar magnetospheric
!     doc-  'sm '  :  solar magnetic
!     doc-  'mag'  :  geomagnetic
!     doc-  'mhd'  :  global mhd simulation system, like 'gse' with
!     doc-            x and y axes mirrored
!     doc-
!     doc-PARAMETERS:
!     doc-  cfr (in,character*3)   'from' coordinate system, for ex. 'gse'
!     doc-  cto (in,character*3)   'to' coordinate system, for ex. 'gsm'
!     doc-  x1,y1,z1 (in,real)     input vector
!     doc-  x2,y2,z2 (out,real)    transformed vector
!     doc-
      implicit none

      type(transform) :: tran

      character*3 cfr,cto
      real*4 x1,y1,z1,x2,y2,z2
      integer i,j,k,l
      integer ifr,ito
      integer kmat
      integer imat(7,7,7)
      real*8 xx1,xx2,yy1,yy2,zz1,zz2
      character*3 clfr,clto

      data (imat(l,1,1),l=1,7)/ 0, 0, 0, 0, 0, 0, 0/
      data (imat(l,2,1),l=1,7)/-1, 0, 0, 0, 0, 0, 0/
      data (imat(l,3,1),l=1,7)/-2, 0, 0, 0, 0, 0, 0/
      data (imat(l,4,1),l=1,7)/-3,-2, 0, 0, 0, 0, 0/
      data (imat(l,5,1),l=1,7)/-4,-3,-2, 0, 0, 0, 0/
      data (imat(l,6,1),l=1,7)/-5,-1, 0, 0, 0, 0, 0/
      data (imat(l,7,1),l=1,7)/ 6,-2, 0, 0, 0, 0, 0/
      data (imat(l,1,2),l=1,7)/ 1, 0, 0, 0, 0, 0, 0/
      data (imat(l,2,2),l=1,7)/ 0, 0, 0, 0, 0, 0, 0/
      data (imat(l,3,2),l=1,7)/-2, 1, 0, 0, 0, 0, 0/
      data (imat(l,4,2),l=1,7)/-3,-2, 1, 0, 0, 0, 0/
      data (imat(l,5,2),l=1,7)/-4,-3,-2, 1, 0, 0, 0/
      data (imat(l,6,2),l=1,7)/-5, 0, 0, 0, 0, 0, 0/
      data (imat(l,7,2),l=1,7)/ 6,-2, 1, 0, 0, 0, 0/
      data (imat(l,1,3),l=1,7)/ 2, 0, 0, 0, 0, 0, 0/
      data (imat(l,2,3),l=1,7)/-1, 2, 0, 0, 0, 0, 0/
      data (imat(l,3,3),l=1,7)/ 0, 0, 0, 0, 0, 0, 0/
      data (imat(l,4,3),l=1,7)/-3, 0, 0, 0, 0, 0, 0/
      data (imat(l,5,3),l=1,7)/-4,-3, 0, 0, 0, 0, 0/
      data (imat(l,6,3),l=1,7)/-5,-1, 2, 0, 0, 0, 0/
      data (imat(l,7,3),l=1,7)/ 6, 0, 0, 0, 0, 0, 0/
      data (imat(l,1,4),l=1,7)/ 2, 3, 0, 0, 0, 0, 0/
      data (imat(l,2,4),l=1,7)/-1, 2, 3, 0, 0, 0, 0/
      data (imat(l,3,4),l=1,7)/ 3, 0, 0, 0, 0, 0, 0/
      data (imat(l,4,4),l=1,7)/ 0, 0, 0, 0, 0, 0, 0/
      data (imat(l,5,4),l=1,7)/-4, 0, 0, 0, 0, 0, 0/
      data (imat(l,6,4),l=1,7)/-5,-1, 2, 3, 0, 0, 0/
      data (imat(l,7,4),l=1,7)/ 6, 3, 0, 0, 0, 0, 0/
      data (imat(l,1,5),l=1,7)/ 2, 3, 4, 0, 0, 0, 0/
      data (imat(l,2,5),l=1,7)/-1, 2, 3, 4, 0, 0, 0/
      data (imat(l,3,5),l=1,7)/ 3, 4, 0, 0, 0, 0, 0/
      data (imat(l,4,5),l=1,7)/ 4, 0, 0, 0, 0, 0, 0/
      data (imat(l,5,5),l=1,7)/ 0, 0, 0, 0, 0, 0, 0/
      data (imat(l,6,5),l=1,7)/-5,-1, 2, 3, 4, 0, 0/
      data (imat(l,7,5),l=1,7)/ 6, 3, 4, 0, 0, 0, 0/
      data (imat(l,1,6),l=1,7)/ 1, 5, 0, 0, 0, 0, 0/
      data (imat(l,2,6),l=1,7)/ 5, 0, 0, 0, 0, 0, 0/
      data (imat(l,3,6),l=1,7)/-2, 1, 5, 0, 0, 0, 0/
      data (imat(l,4,6),l=1,7)/-3,-2, 1, 5, 0, 0, 0/
      data (imat(l,5,6),l=1,7)/-4,-3,-2, 1, 5, 0, 0/
      data (imat(l,6,6),l=1,7)/ 0, 0, 0, 0, 0, 0, 0/
      data (imat(l,7,6),l=1,7)/ 6,-2, 1, 5, 0, 0, 0/
      data (imat(l,1,7),l=1,7)/ 2,-6, 0, 0, 0, 0, 0/
      data (imat(l,2,7),l=1,7)/-1, 2, 6, 0, 0, 0, 0/
      data (imat(l,3,7),l=1,7)/-6, 0, 0, 0, 0, 0, 0/
      data (imat(l,4,7),l=1,7)/-3,-6, 0, 0, 0, 0, 0/
      data (imat(l,5,7),l=1,7)/-4,-3,-6, 0, 0, 0, 0/
      data (imat(l,6,7),l=1,7)/-5,-1, 2,-6, 0, 0, 0/
      data (imat(l,7,7),l=1,7)/ 0, 0, 0, 0, 0, 0, 0/
!
      if(tran%icalled.eq.0.or.tran%iscalled.ne.0) then
         tran%icalled=1
         tran%ccfr='XXX'
         tran%ccto='xyz'
      endif
      tran%iscalled=0
!
      xx1=dble(x1)
      yy1=dble(y1)
      zz1=dble(z1)
      clfr=cfr
      clto=cto
!
      if(clfr.ne.tran%ccfr(1:3).or.clto.ne.tran%ccto(1:3)) then
         ifr=0
         if(clfr.eq.'GEI'.or.clfr.eq.'gei')ifr=1
         if(clfr.eq.'GEO'.or.clfr.eq.'geo')ifr=2
         if(clfr.eq.'GSE'.or.clfr.eq.'gse')ifr=3
         if(clfr.eq.'GSM'.or.clfr.eq.'gsm')ifr=4
         if(clfr(1:2).eq.'SM'.or.clfr(1:2).eq.'sm')ifr=5
         if(clfr.eq.'MAG'.or.clfr.eq.'mag')ifr=6
         if(clfr.eq.'MHD'.or.clfr.eq.'mhd')ifr=7
         ito=0
         if(clto.eq.'GEI'.or.clto.eq.'gei')ito=1
         if(clto.eq.'GEO'.or.clto.eq.'geo')ito=2
         if(clto.eq.'GSE'.or.clto.eq.'gse')ito=3
         if(clto.eq.'GSM'.or.clto.eq.'gsm')ito=4
         if(clto(1:2).eq.'SM'.or.clto(1:2).eq.'sm')ito=5
         if(clto.eq.'MAG'.or.clto.eq.'mag')ito=6
         if(clto.eq.'MHD'.or.clto.eq.'mhd')ito=7
         if(ifr.lt.1.or.ito.lt.1) then
            write(0,*)' error cotr: ifr,ito ',ifr,ito
            write(0,*)'             clfr=',clfr
            write(0,*)'             clto=',clto
            stop
         endif
!
         tran%ccfr=clfr
         tran%ccto=clto
         do i=1,3
            do j=1,3
               tran%cmat(i,j)=0.0d0
               if(i.eq.j) tran%cmat(i,j)=1.0d0
            end do
         end do

         do k=1,7
            kmat=imat(k,ifr,ito)
            if(kmat.eq.0) goto 100
            do i=1,3
               do j=1,3
                  tran%tmpmat(i,j,1)=tran%pmat(i,1,kmat)*tran%cmat(1,j) &
                        +tran%pmat(i,2,kmat)*tran%cmat(2,j) &
                        +tran%pmat(i,3,kmat)*tran%cmat(3,j)
               end do
            end do
            do i=1,3
               do j=1,3
                  tran%cmat(i,j)=tran%tmpmat(i,j,1)
               end do
            end do
         end do
      endif
!
100   continue
      xx2=tran%cmat(1,1)*xx1+tran%cmat(1,2)*yy1+tran%cmat(1,3)*zz1
      yy2=tran%cmat(2,1)*xx1+tran%cmat(2,2)*yy1+tran%cmat(2,3)*zz1
      zz2=tran%cmat(3,1)*xx1+tran%cmat(3,2)*yy1+tran%cmat(3,3)*zz1
      x2=sngl(xx2)
      y2=sngl(yy2)
      z2=sngl(zz2)
!
      return
   end subroutine cotr


!----------------------------------------------------
   subroutine cotr_set_1(iy,mo,id,ih,mi,se,tran)
!----------------------------------------------------
!doc-
!doc-FUNCTION:
!doc-  computes coordinate transformation matrices
!doc-  for cotr() for a given time
!doc-
!doc-PARAMETERS:
!doc-  iy (in,integer):  year (nn or nnnn notation) (1900<iy<2000)
!doc-  mo (in,integer):  month             (1<=mo<=12)
!doc-  id (in,integer):  day of month      (1<=id<=31)
!doc-  ih (in,integer):  hour of day       (0<=ih<24)
!doc-  mi (in,integer):  minute of hour    (0<=mi<60)
!doc-  se (in,real):     seconds of minute (0.0<=se<60.0)
!doc-  tran(out,transform): Transform to be passed to cotr
!doc-
!doc-NOTES:
!doc-  1.  dipole coordinates are computed from IGRF g10,g11,h11
!doc-      coefficients between 1945 and 1990 with linear time
!doc-      interpolation.  Before 1945 coefficients for 1945 are
!doc-      used and after 1990 coefficients for 1990 are used.
!doc-  2.  internal arithmetic is handled in double precision
!doc-
!doc-  3.  for iy=1967 mo=1 id=1 ih=0 mi=0 se=any all transformations
!doc-      are set to identity
!doc-
!doc-
!doc-REFERENCES:
!doc-
!doc-        Almanac for Computers 1991
!doc-        Nautical Almanac Office
!doc-        US Naval Observatory
!doc-        Washington, DC
!doc-
!doc-        M A Hapgood
!doc-        Space physics coordinate transformations: A user guide
!doc-        Planet. Space Sci., 40, 711, 1992
!doc-
      implicit none

      type(transform) :: tran

      integer iy,mo,id,ih,mi
      real*4 se

      integer ier
      integer i,j,k
      integer i1,i2,i3,i4
      integer jy, mjd
      real*8 zero, one, two, twopi
      real*8 eps
      real*8 d1
      real*8 psi,pih
      real*8 t, tmp, tmpco, tmpsi
      real*8 gg11, gg10, hh11
      real*8 gmsth, gmstd, gang
      real*8 uthour
      real*8 w1
      real*8 xmjd, xjd0, xjd
      real*8 xxp, xmu, xxl, xm, xy, xl, xls
      real*8 qx,qy,qz,qxg,qyg,qzg
      real*8 tmpx,tmpy,tmpz,tmp1,tmp2

      integer mdays(12,2)
      data mdays / 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, &
            334, 0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335 /
      real*4 tig,g10,g11,h11  !These are arrays.
      integer nyrsIGRF
      parameter (nyrsIGRF=19)
      dimension tig(nyrsIGRF)  !year
      dimension g10(nyrsIGRF),g11(nyrsIGRF),h11(nyrsIGRF) !IGRF coefficients
      data tig( 1) /1000.00/
      data g10( 1),g11( 1),h11( 1)/ -30594.00, -2285.00, 5810.00/
      data tig( 2) /1945.00/
      data g10( 2),g11( 2),h11( 2)/ -30594.00, -2285.00, 5810.00/
      data tig( 3) /1950.00/
      data g10( 3),g11( 3),h11( 3)/ -30554.00, -2250.00, 5815.00/
      data tig( 4) /1955.00/
      data g10( 4),g11( 4),h11( 4)/ -30500.00, -2215.00, 5820.00/
      data tig( 5) /1960.00/
      data g10( 5),g11( 5),h11( 5)/ -30421.00, -2169.00, 5791.00/
      data tig( 6) /1965.00/
      data g10( 6),g11( 6),h11( 6)/ -30334.00, -2119.00, 5776.00/
      data tig( 7) /1970.00/
      data g10( 7),g11( 7),h11( 7)/ -30220.00, -2068.00, 5737.00/
      data tig( 8) /1975.00/
      data g10( 8),g11( 8),h11( 8)/ -30100.00, -2013.00, 5675.00/
      data tig( 9) /1980.00/
      data g10( 9),g11( 9),h11( 9)/ -29992.00, -1956.00, 5604.00/
      data tig(10) /1985.00/
      data g10(10),g11(10),h11(10)/ -29873.00, -1905.00, 5500.00/
      data tig(11) /1990.00/
      data g10(11),g11(11),h11(11)/ -29775.00, -1848.00, 5406.00/
      data tig(12) /1995.00/
      data g10(12),g11(12),h11(12)/ -29692.00, -1784.20, 5306.00/
      data tig(13) /2000.00/
      data g10(13),g11(13),h11(13)/ -29619.40, -1728.20, 5186.10/
      data tig(14) /2005.00/
      data g10(14),g11(14),h11(14)/ -29554.63, -1669.05, 5077.99/
      data tig(15) /2010.00/
      data g10(15),g11(15),h11(15)/ -29496.57, -1586.42, 4944.26/
      data tig(16) /2015.00/
      data g10(16),g11(16),h11(16)/ -29441.46, -1501.77, 4795.99/
      data tig(17) /2020.00/
      data g10(17),g11(17),h11(17)/ -29404.80, -1450.90, 4652.50/
! extrapolate: 2020 - 2025 (sv=5.7,7.4,-25.9)
      data tig(18) /2025.00/
      data g10(18),g11(18),h11(18)/ -29376.30, -1413.90, 4523.00/
! flat after 2025
      data tig(19) /9999.00/
      data g10(19),g11(19),h11(19)/ -29376.30, -1413.90, 4523.00/
      parameter(pih=1.570796372d0,twopi=6.283185307179586476925287d0)
      parameter(zero=0.0d0,one=1.0d0,two=2.0d0)
!
!..... check input consistency
!

      tran%year = iy
      tran%month = mo
      tran%day = id
      tran%hour = ih
      tran%minute = mi
      tran%seconds = se

      jy=iy
      if(jy.lt.200)jy=jy+1900
      ier=0
      if(jy.lt.1901) ier=1
      if(jy.gt.2025) ier=7   ! extrapolation period ends 1/1/2025 00:00
      if(mo.lt.1.or.mo.gt.12) ier=2
      if(id.lt.1.or.id.gt.31) ier=3
      if(ih.lt.0.or.ih.gt.23) ier=4
      if(mi.lt.0.or.mi.gt.63) ier=5
      if(se.lt.0.0.or.se.gt.60.0) ier=6
      if(ier.ne.0) then
         write(0,*)'error cotr_set, ier= ',ier
         write(0,*)jy,mo,id,ih,mi,se
         stop
      endif
!
      tran%iscalled=1
!
!.....  universal time of day in hours (UT1)
!
      uthour=dble(float(ih))+(dble(float(mi))/60.0d0)+dble(se)/3600.0d0
!
!..... full julian day
!
      i1=367*jy
      i2=(mo+9)/12
      i2=(i2+jy)*7
      i2=i2/4
      i3=(275*mo)/9
      i4=100*jy+mo
      d1=one
      if((dble(i4)-190002.5d0).lt.zero)d1=(-d1)
      xjd=dble(i1)-dble(i2)+dble(i3)+dble(id)+ &
            1721013.5d0+uthour/24.0d0-0.5d0*d1+0.5
!
!..... julian day at 0 UT
!
      xjd0=xjd-(uthour/24.0d0)
!
!.....  modified julian day
!
      xmjd=xjd-2400000.5d0
      mjd=int(xmjd)
!
!.....  set to identity transformation if iy=1967,....
!       except for the MHD transformation which still flips x- y- axes
!
      if(jy.eq.1967.and.mo.eq.1.and.id.eq.1.and.ih.eq.0.and.mi.eq.0)then
         do k=-7,7
            do j=1,3
               do i=1,3
                  tran%pmat(i,j,k)=0.0d0
                  if(i.eq.j)tran%pmat(i,j,k)=1.0d0
               end do
            end do
         end do
         do i=1,3
            do j=1,3
               tran%pmat(j,i,6)=zero
            end do
         end do
         tran%pmat(1,1,6)=(-1.0d0)
         tran%pmat(2,2,6)=(-1.0d0)
         tran%pmat(3,3,6)=(1.0d0)
         do i=1,3
            do j=1,3
               tran%pmat(j,i,-6)=tran%pmat(i,j,6)
            end do
         end do

         return
      endif
!
!
!..... solar coordinates
!
      t=(xjd-2451545.0d0)/36525.0d0
      tran%t0=(xjd0-2451545.0d0)/36525.0d0
      xm=357.528d0+35999.050d0*t
      xl=280.460d0+36000.772d0*t
      xm=dmod(xm+360.0d3,360.0d0)
      xl=dmod(xl+360.0d3,360.0d0)
      tmp1=rad*xm
      tmp2=2.0d0*rad*xm
      xls=xl+((1.915d0-0.0048*tran%t0)*dsin(tmp1))+(0.020d0*dsin(tmp2))
      eps=23.439d0-0.013d0*t
      eps=dmod(eps+360.0d3,360.0d0)
!
!..... greenwich mean siderial time
!
      gmsth=6.69737456d0 +2400.051336d0*tran%t0 +0.0000258622d0* &
            tran%t0*tran%t0 +1.002737909d0*uthour
      gmsth=dmod(gmsth+24.0d3,24.0d0)
      gmstd=15.0d0*gmsth
      gang=rad*gmstd
!
      eps=rad*eps
      xls=rad*xls
!
!.... gei to geo
!
      do i=1,3
         do j=1,3
            tran%pmat(j,i,1)=zero
         end do
      end do
      tmpsi=dsin(gang)
      tmpco=dcos(gang)
      tran%pmat(1,1,1)=tmpco
      tran%pmat(2,2,1)=tmpco
      tran%pmat(3,3,1)=one
      tran%pmat(2,1,1)=-tmpsi
      tran%pmat(1,2,1)=tmpsi
      do i=1,3
         do j=1,3
            tran%pmat(j,i,-1)=tran%pmat(i,j,1)
         end do
      end do
!
!.... gei to gse
!
      do i=1,3
         do j=1,3
            tran%tmpmat(j,i,1)=zero
         end do
      end do
      tmpsi=dsin(xls)
      tmpco=dcos(xls)
      tran%tmpmat(1,1,1)=tmpco
      tran%tmpmat(2,2,1)=tmpco
      tran%tmpmat(3,3,1)=one
      tran%tmpmat(2,1,1)=-tmpsi
      tran%tmpmat(1,2,1)=tmpsi
!
      do i=1,3
         do j=1,3
            tran%tmpmat(j,i,2)=zero
         end do
      end do
      tmpsi=dsin(eps)
      tmpco=dcos(eps)
      tran%tmpmat(1,1,2)=one
      tran%tmpmat(2,2,2)=tmpco
      tran%tmpmat(3,3,2)=tmpco
      tran%tmpmat(3,2,2)=-tmpsi
      tran%tmpmat(2,3,2)=tmpsi
!
      do i=1,3
         do j=1,3
            tran%pmat(i,j,2)=tran%tmpmat(i,1,1)*tran%tmpmat(1,j,2) &
                  +tran%tmpmat(i,2,1)*tran%tmpmat(2,j,2) &
                  +tran%tmpmat(i,3,1)*tran%tmpmat(3,j,2)
         end do
      end do

      do i=1,3
         do j=1,3
            tran%pmat(j,i,-2)=tran%pmat(i,j,2)
         end do
      end do
!
!
! .... gse to gsm
!
!     CHECKME-CHECKME-CHECKME
!     These were uninitialized
      gg10 = 0.d0
      gg11 = 0.d0
      hh11 = 0.d0
!
      xy=100.0d0*(20.0d0+t)
      do k=1,nyrsIGRF-1
         if(xy.ge.tig(k).and.xy.le.tig(k+1)) then
            tmp=(xy-tig(k))/(tig(k+1)-tig(k))
            gg10=(one-tmp)*g10(k)+tmp*g10(k+1)
            gg11=(one-tmp)*g11(k)+tmp*g11(k+1)
            hh11=(one-tmp)*h11(k)+tmp*h11(k+1)
            exit
         endif
      end do

      tmp1=hh11/gg11
      xxl=datan(tmp1)
      tmp1=(gg11*dcos(xxl)+hh11*dsin(xxl))/gg10
      xxp=pih-dasin( tmp1 )
!
      qxg=dcos(xxp)*dcos(xxl)
      qyg=dcos(xxp)*dsin(xxl)
      qzg=dsin(xxp)
      tmpx=tran%pmat(1,1,-1)*qxg+tran%pmat(1,2,-1)*qyg + &
            tran%pmat(1,3,-1)*qzg
      tmpy=tran%pmat(2,1,-1)*qxg+tran%pmat(2,2,-1)*qyg + &
            tran%pmat(2,3,-1)*qzg
      tmpz=tran%pmat(3,1,-1)*qxg+tran%pmat(3,2,-1)*qyg + &
            tran%pmat(3,3,-1)*qzg
      qx=tran%pmat(1,1,2)*tmpx+tran%pmat(1,2,2)*tmpy + &
            tran%pmat(1,3,2)*tmpz
      qy=tran%pmat(2,1,2)*tmpx+tran%pmat(2,2,2)*tmpy + &
            tran%pmat(2,3,2)*tmpz
      qz=tran%pmat(3,1,2)*tmpx+tran%pmat(3,2,2)*tmpy + &
            tran%pmat(3,3,2)*tmpz
      psi=datan2(qy,qz)
      do i=1,3
         do j=1,3
            tran%pmat(j,i,-3)=zero
         end do
      end do
      tmpsi=dsin(psi)
      tmpco=dcos(psi)
      tran%pmat(1,1,-3)=one
      tran%pmat(2,2,-3)=tmpco
      tran%pmat(3,3,-3)=tmpco
      tran%pmat(3,2,-3)=-tmpsi
      tran%pmat(2,3,-3)=tmpsi
      do i=1,3
         do j=1,3
            tran%pmat(j,i,3)=tran%pmat(i,j,-3)
         end do
      end do
!
!.... gsm to sm
!
      xmu=datan(qx/sqrt(qy*qy+qz*qz))
      do i=1,3
         do j=1,3
            tran%pmat(j,i,-4)=zero
         end do
      end do
      tmpsi=dsin(xmu)
      tmpco=dcos(xmu)
      tran%pmat(1,1,-4)=tmpco
      tran%pmat(2,2,-4)=one
      tran%pmat(3,3,-4)=tmpco
      tran%pmat(3,1,-4)=-tmpsi
      tran%pmat(1,3,-4)=tmpsi
      do i=1,3
         do j=1,3
            tran%pmat(j,i,4)=tran%pmat(i,j,-4)
         end do
      end do
!
!.... geo to mag
!
      w1=xxp-pih
      do i=1,3
         do j=1,3
            tran%tmpmat(j,i,1)=zero
         end do
      end do
      do i=1,3
         do j=1,3
            tran%tmpmat(j,i,2)=zero
         end do
      end do
      tmpsi=dsin(w1)
      tmpco=dcos(w1)
      tran%tmpmat(1,1,1)=tmpco
      tran%tmpmat(2,2,1)=one
      tran%tmpmat(3,3,1)=tmpco
      tran%tmpmat(3,1,1)=-tmpsi
      tran%tmpmat(1,3,1)=tmpsi
      tmpsi=dsin(xxl)
      tmpco=dcos(xxl)
      tran%tmpmat(1,1,2)=tmpco
      tran%tmpmat(2,2,2)=tmpco
      tran%tmpmat(3,3,2)=one
      tran%tmpmat(2,1,2)=-tmpsi
      tran%tmpmat(1,2,2)=tmpsi
      do i=1,3
         do j=1,3
            tran%pmat(i,j,5)=tran%tmpmat(i,1,1)*tran%tmpmat(1,j,2) &
                  +tran%tmpmat(i,2,1)*tran%tmpmat(2,j,2) &
                  +tran%tmpmat(i,3,1)*tran%tmpmat(3,j,2)
         end do
      end do
      do i=1,3
         do j=1,3
            tran%pmat(j,i,-5)=tran%pmat(i,j,5)
         end do
      end do
!
!.....  gse to mhd
!
      do i=1,3
         do j=1,3
            tran%pmat(j,i,6)=zero
         end do
      end do
      tran%pmat(1,1,6)=(-1.0d0)
      tran%pmat(2,2,6)=(-1.0d0)
      tran%pmat(3,3,6)=(1.0d0)
      do i=1,3
         do j=1,3
            tran%pmat(j,i,-6)=tran%pmat(i,j,6)
         end do
      end do
!
      return
   end subroutine cotr_set_1

!     Convenience functions:
!----------------------------------------------------
   subroutine cotr_set_r8(rtime,tran)
!----------------------------------------------------
      use date_lib
      implicit none
      type(transform),intent(out) :: tran
      real*8,intent(in) :: rtime

      integer iy,mo,id,ih,mi
      real sec
      call epoch1966(rtime,iy,mo,id,ih,mi,sec,1)
      if(iy.lt.200)then
         iy = iy+1900
      endif
      call cotr_set_1(iy,mo,id,ih,mi,sec,tran)
   end subroutine cotr_set_r8

!---------------------------------------------------------------
   subroutine mhdmlt(iy,mo,id,ih,mi,se,pmhd,tmhd,xmlt,colat)
!---------------------------------------------------------------
      !cdoc-
      !cdoc-FUNCTION:
      !cdoc-  convert MHD longitude (-180,180) and colatitude (0,180)
      !cdoc-  to magnetic local time (0-24) and colatitude
      !cdoc-
      !cdoc-PARAMETERS:
      !cdoc-  iy,mo,id,ih,mi,se (in):  time in UT
      !cdoc-  pmhd (in,real):  deg longitude in MHD system (-180.0,180.0)
      !cdoc-  tmhd (in,real):  deg colatitude in MHD system (0.0,180.0)
      !cdoc-  xmlt (out,real): hours magnetic local time (0.0-24.0)
      !cdoc-  colat (out,real): deg magnetic colatitude (0.0,180.0)
      !cdoc-
      implicit none

      type(transform) :: tran
      integer iy,mo,id,ih,mi
      real se,pmhd,tmhd,xmlt,colat

      real x1,y1,z1,x2,y2,z2
      real rr,pp,tt

      call cotr_set(iy,mo,id,ih,mi,se,tran)
      call degxyz(1.0,pmhd,tmhd,x1,y1,z1)
      call cotr(tran,'mhd','sm ',x1,y1,z1,x2,y2,z2)
      call xyzdeg(x2,y2,z2,rr,pp,tt)
      colat=tt
      xmlt=(pp+180.0)/15.0
      return
   end subroutine mhdmlt

!---------------------------------------------------------
   subroutine diptil_1(iy,mo,id,ih,mi,se,degsun,degy)
!---------------------------------------------------------
      !cdoc-
      !cdoc-FUNCTION:
      !cdoc-  compute dipole tilt angles for a given time
      !cdoc-
      !cdoc-PARAMETERS:
      !cdoc-  iy,mo,id,ih,mi,se (in):  time in UT
      !cdoc-  degsun (out,real): deg tilt in GSE x-z plane
      !cdoc-  degy (out,real):   deg tilt in GSE y-z plane
      !cdoc-

      implicit none

      type(transform) :: tran
      integer iy,mo,id,ih,mi
      real se,degsun,degy

      call cotr_set(iy,mo,id,ih,mi,se,tran)
      call diptil_tran(tran,degsun,degy)
      return
   end subroutine diptil_1

   subroutine diptil_tran(tran,degsun,degy)
      implicit none
      real,intent(out) :: degsun,degy
      type(transform),intent(in) :: tran
      real :: xsm,ysm,zsm,xgse,ygse,zgse

      xsm = 0.0; ysm = 0.0; zsm = 1.0
      call cotr(tran,'sm ','gse',xsm,ysm,zsm,xgse,ygse,zgse)
      degsun=deg*atan2(xgse,zgse)
      degy=deg*atan2(ygse,zgse)
   end subroutine diptil_tran

end module new_cotr

module ground_perturbation_m
   implicit none
   private

   public :: iopar, gradpt, ground

   integer :: np, nt
   real, allocatable, dimension(:) :: hh1, hh2, hh3, f1, f2, awork

   integer, parameter :: NIOWK_ = 19000000
contains

! -------------------------------------------------------------------
   subroutine iopar_initialize(np_, nt_)
! -------------------------------------------------------------------
      integer, intent(in) :: np_, nt_

      integer :: npt
      logical, save :: inited = .false.

      if (.not. inited) then
         np = np_
         nt = nt_
         npt = np * nt
         allocate(hh1(npt+1), hh2(npt+1), hh3(npt+1), f1(npt+1), f2(npt+1))
         allocate(awork(NIOWK_))
         inited = .true.
      end if
      if (np /= np_ .or. nt /= nt_) then
         write(0,*) 'Error in iopar_initialize: np,nt do not match'
         stop
      end if
   end subroutine iopar_initialize

! -------------------------------------------------------------------
   subroutine iopar_finalize()
! -------------------------------------------------------------------

      deallocate(hh1, hh2, hh3, f1, f2)
      deallocate(awork)
   end subroutine iopar_finalize


! -------------------------------------------------------------------
   subroutine iopar(np,nt,fac,pot,sigp,sigh,ep,et, &
         ctiot,ctiop,tau,ctaup,ctaut,cpolp,cpolt,delbr,delbp,delbt,xjh)
! -------------------------------------------------------------------
      integer, intent(in) :: np, nt
      !f2py intent(hide) :: np, nt
      real, dimension(np, nt), intent(in) :: fac, pot, sigp, sigh
      real, dimension(np, nt), intent(out) :: tau
      real, dimension(np, nt), intent(out) :: ctiot, ctiop, ctaup, ctaut, cpolp, cpolt
      real, dimension(np, nt), intent(out) :: ep, et, delbr, delbp, delbt, xjh

      real t, cost, sint, sini, dp, dt, f, p, pi, re
      real spp, spt, stt
      integer i, ip, it, iv, niogo, niopy, niowk, niox, nioy
      integer nniowk

      call iopar_initialize(np, nt)

      ! ..... electric field
      call gradpt(pot,np,nt,et,ep)

      pi=4.0*atan(1.0)
      dp=2.0*pi/float(np-1)
      dt=pi/float(nt-1)
      re=6372.0e3
      f=1.0/re

      iv=0
      i=0
      do it=1,nt
         t=float(it-1)*dt
         cost=cos(t)
         sint=sin(t)
         sini=amax1(0.05,2.0*abs(cost)/sqrt(1.0+3.0*cost*cost))
         do ip=1,np
            p=float(ip-1)*dp
            i=i+1
            f1(i)=f*f
            f2(i)=0.0
            !..... total ionospheric current
            stt=sigp(ip,it)/(sini*sini)
            spt=sigh(ip,it)/sini
            spp=sigp(ip,it)
            ctiot(ip,it)=stt*et(ip,it)+spt*ep(ip,it)
            ctiop(ip,it)=spp*ep(ip,it)-spt*et(ip,it)
            !..... joule heat rate
            xjh(ip,it)=ctiot(ip,it)*et(ip,it)+ctiop(ip,it)*ep(ip,it)
            delbt(ip,it)=fac(ip,it)
         end do
      end do

      !...... solve poisson eq for the potential of the irrotational
      !       (poloidal) current
      if(iv.ne.0)write(0,*)' solving poisson equation '
      niox=20
      nioy=10
      niogo=4
      niopy=2*nioy
      nniowk =(size(awork,1)/2)-10
      niowk=nniowk/2
      !.... set up solver
      call io4(0,niox,nioy,niogo,niopy,f1,f2,delbt,tau,np,nt,awork,niowk,hh1,hh2,hh3)
      !.... factor matrix
      call io4(1,niox,nioy,niogo,niopy,f1,f2,delbt,tau,np,nt,awork,niowk,hh1,hh2,hh3)
      !.... solve matrix and interpolate
      call io4(2,niox,nioy,niogo,niopy,f1,f2,delbt,tau,np,nt,awork,niowk,hh1,hh2,hh3)

      !...... irrotational (poloidal)  current
      call gradpt(tau,np,nt,ctaut,ctaup)

      !...... toroidal (div free) part
      do it=1,nt
         do ip=1,np
            cpolt(ip,it)=ctiot(ip,it)-ctaut(ip,it)
            cpolp(ip,it)=ctiop(ip,it)-ctaup(ip,it)
         end do
      end do
      !..... ground magnetic perturbation
      call ground(np,nt,cpolp,cpolt,delbp,delbt,delbr)

      return
   end subroutine iopar


! -------------------------------------------------------------------
   subroutine gradpt(pot,np,nt,et,ep)
! -------------------------------------------------------------------
! calculate meridional and azimuthal electric field from
! the potential, i.e.  (ep,et) = -grad pot

      integer, intent(in) :: np, nt
      !f2py intent(hide) :: np, nt
      real, dimension(np, nt), intent(in) :: pot
      real, dimension(np, nt), intent(out) :: ep, et

      integer ip,it,it0,it1,ip0,ip1
      real pi,dp,dt,f,st,t

      pi=4.0*atan(1.0)
      dp=2.0*pi/float(np-1)
      dt=pi/float(nt-1)
      f=1.0/6372.0e3
      do ip=1,np
         do it=1,nt
            it0=max0(1,it-1)
            it1=min0(nt,it+1)
            et(ip,it)=-f*(pot(ip,it1)-pot(ip,it0))/(float(it1-it0)*dt)
            ep(ip,it)=0.0
            if( (it.gt.1) .and. (it.lt.nt) ) then
               t=float(it-1)*dt
               st=sin(t)
               ip0=ip-1
               if(ip0.lt.1)ip0=np-1
               ip1=ip+1
               if(ip1.gt.np)ip1=2
               ep(ip,it)=-f*(pot(ip1,it)-pot(ip0,it))/(2.0*dp*st)
            endif
         end do
      end do
   end subroutine gradpt

! ----------------------------------------------------------------
   subroutine ground(np,nt,cpolp,cpolt,delbp,delbt,delbr)
!----------------------------------------------------------------
      integer, intent(in) :: np, nt
      !f2py intent(hide) :: np, nt
      real, dimension(np, nt), intent(in) :: cpolp, cpolt
      real, dimension(np, nt), intent(out) :: delbp, delbt, delbr

      real, dimension(500) :: sp,cp,st,ct,st1,st2,ddf
      integer ip,it,jp,jt,nt1,nt2
      real pi,dp,dt,f
      real xmue0,re,reh,h,dd,d2
      real x0,y0,z0,x1,y1,z1,r3i
      real xjx,xjy,xjz,rx,ry,rz,x,y,z
      real dbx,dby,dbz,dbr,dbp,dbt
      real df,p,t,tdeg,tmp_1,xjp,xjr,xjt

      ! write(0,*)'start ground',np,nt
      pi=4.0*atan(1.0)
      xmue0=4.0e-7*pi
      dp=2.0*pi/float(np-1)
      dt=pi/float(nt-1)
      re=6372.0e3
      h=90.0e3    !  ionosphere height
      reh=re+h
      dd=600.0e3   !  radius to which to integrate
      d2=dd*dd

      do ip=1,np
         p=float(ip-1)*dp
         sp(ip)=sin(p)
         cp(ip)=cos(p)
      end do
      do it=1,nt
         t=float(it-1)*dt
         st(it)=sin(t)
         ct(it)=cos(t)
         st1(it)=sin(t-0.5*dt)
         st2(it)=sin(t+0.5*dt)
         ddf(it)=0.5*re*re*dp*dt*(st1(it)+st2(it))*xmue0/(4.0*pi)
      end do

      do it=1,nt
         nt1=max0(2,it-14)
         nt2=min0(nt-1,it+14)
         t=float(it-1)*dt
         tdeg=t*180.0/pi
         do ip=1,np
            delbr(ip,it)=0.0
            delbp(ip,it)=0.0
            delbt(ip,it)=0.0
            if(tdeg.gt.45.0.and.tdeg.lt.135.0) cycle
            p=float(ip-1)*dp
            x0=cp(ip)*st(it)*re
            y0=sp(ip)*st(it)*re
            z0=ct(it)*re
            dbx=0.0
            dby=0.0
            dbz=0.0

            !..... integration loop
            do jt=nt1,nt2
               do jp=1,np-1
                  x1=cp(jp)*st(jt)*reh
                  y1=sp(jp)*st(jt)*reh
                  z1=ct(jt)*reh
                  dd=(x1-x0)**2+(y1-y0)**2+(z1-z0)**2
                  if(dd.gt.d2) cycle
                  rx=x0-x1
                  ry=y0-y1
                  rz=z0-z1
                  r3i=1.0/(dd*sqrt(dd))
                  df=ddf(jt)*r3i
                  xjr=0.0
                  xjp=cpolp(ip,it)
                  xjt=cpolt(ip,it)
                  call vec_pol_cart(xjr,xjp,xjt,xjx,xjy,xjz,sp(jp),cp(jp),st(jt),ct(jt))
                  call cross11(xjx,xjy,xjz,rx,ry,rz,x,y,z)
                  dbx=dbx+df*x
                  dby=dby+df*y
                  dbz=dbz+df*z
               end do
            end do ! integration loop

            call vec_cart_pol(dbx,dby,dbz,dbr,dbp,dbt,sp(ip),cp(ip),st(it),ct(it))
            delbr(ip,it)=dbr
            delbp(ip,it)=dbp
            delbt(ip,it)=dbt
         end do
      end do

   contains

      subroutine vec_cart_pol(AX,AY,AZ,AR,AP,AT,SP,CP,ST,CT)
         real AX,AY,AZ,SP,CP,ST,CT
         real AR,AP,AT

         real tmp_1

         tmp_1=AX*CP+AY*SP
         AR=tmp_1*ST+AZ*CT
         AT=tmp_1*CT-AZ*ST
         AP=AY*CP-AX*SP

      end subroutine vec_cart_pol


      subroutine vec_pol_cart(AR,AP,AT,AX,AY,AZ,SP,CP,ST,CT)
         real AX,AY,AZ,SP,CP,ST,CT
         real AR,AP,AT

         real tmp_1

         ! tmp_1=AR*ST+AT*CT
         tmp_1=AT*CT
         AX=tmp_1*CP-AP*SP
         AY=tmp_1*SP+AP*CP
         ! AZ=AR*CT-AT*ST
         AZ=AT*ST

      end subroutine vec_pol_cart

      subroutine cross11(AX,AY,AZ,BX,BY,BZ,CX,CY,CZ)
         real AX,AY,AZ,BX,BY,BZ,CX,CY,CZ

         CX=AY*BZ-AZ*BY
         CY=AZ*BX-AX*BZ
         CZ=AX*BY-AY*BX

      end subroutine cross11

   end subroutine ground

end module ground_perturbation_m

# Installing and Running OpenGGCM

## System Requirements

OpenGGCM has fairly minimal dependencies:

**Required dependencies:**

- Fortran90 compiler (recommended: `gfortran`)
- MPI
- perl
- autotools

**Optional dependencies:**

- HDF5 (if using XDMF/HDF5 output)
- ADIOS2 (for code coupling)
- cmake

```{todo}
A devcontainer can be a convenient way of getting everything in place to build / run / develop OpenGGCM, but needs documentation and unfortunately is not usually a feasible way of running production.
```

### Marvin

On UNH's Cray "Marvin", I set up the environment for OpenGGCM using conda. (This
should work on other machines, too, if one opts to use conda. Most machines are
going to have a way to set up environments, it's generally probably best to
stick with that.)

```{todo}
Add how to installing (mini-)conda.
```

Create a `.condarc` in your home directory with the following content:

```sh
.condarc
channels:                                                                                                                      - conda-forge
 - defaults
channel_priority: strict
```

Create an environment for OpenGGCM:

```sh
conda create -n ggcm

conda install openmpi-mpifort
conda install "adios2=*=mpi_openmpi_*"
conda install cmake
conda install hdf5
conda install jupyter
conda install xarray
conda install dask
conda install matplotlib
pip install ggcmpy
```

You also want to set the environment variable `OPENGGCMDIR` to the location of
the OpenGGCM source you cloned from github above, e.g. by adding the following
to your `.bashrc` or `.zshrc`.

```sh
export OPENGGCMDIR=$HOME/src/openggcm # adjust for your OpenGGCM source location
```

Activate your environment.

```sh
[kaig@ln-0001 openggcm]$ conda activate ggcm
(ggcm) [kaig@ln-0001 openggcm]$
```

## Obtaining OpenGGCM

### Repository Access

OpenGGCM is maintained in a private github repository. Please contact Kai
<kai.germaschewski@unh.edu> or Doug <william.cramer@unh.edu> to be given access.

### Cloning the repository

```{todo}
* Setting up ssh or alternative github authentication
* forking the repo if planning to do development
```

```sh
(ggcm) [kaig@ln-0001 ~]$ mkdir src
(ggcm) [kaig@ln-0001 ~]$ cd src
(ggcm) [kaig@ln-0001 src]$ git clone git@github.com:unh-hpc/openggcm.git
Cloning into 'openggcm'...
remote: Enumerating objects: 70227, done.
remote: Counting objects: 100% (940/940), done.
remote: Compressing objects: 100% (316/316), done.
remote: Total 70227 (delta 682), reused 756 (delta 621), pack-reused 69287 (from 2)
Receiving objects: 100% (70227/70227), 86.08 MiB | 42.67 MiB/s, done.
Resolving deltas: 100% (54561/54561), done.
Updating files: 100% (1615/1615), done.
```

This should get you a copy of the OpenGGCM source in `src/openggcm`.

Have the autotools prepare the code for building:

```sh
(ggcm) [kaig@ln-0001 src]$ cd openggcm
(ggcm) [kaig@ln-0001 openggcm]$ ./autogen.sh
```

## Building and Installing OpenGGCM Utilities

Compile the utilities:

```sh
(ggcm) [kaig@ln-0001 openggcm]$ cd util
(ggcm) [kaig@ln-0001 util]$ ./configure --prefix=$HOME
[...]
(ggcm) [kaig@ln-0001 util]$ make
[...]
(ggcm) [kaig@ln-0001 util]$ make install
[...]
```

This compiles and install the utilities into `$PREFIX/bin`, so with the prefix
set to `$HOME` into the `bin/` folder in your home directory. Add that folder to
your path (again, something you may want to do in `.bashrc` or similar to
persist it).

```sh
(ggcm) [kaig@ln-0001 util]$ export PATH=$HOME/bin:$PATH
(ggcm) [kaig@ln-0001 util]$ fppn # make sure the fppn tool is now available
usage: fppn [-q] [-c] [-v1] [-v2] [-v3] [-v4] [-longout] [-fold] file
```

## Setting up a run

Let's set up a sample run, and run it.

```sh
(ggcm) [kaig@ln-0001 work]$ mkdir test0003
(ggcm) [kaig@ln-0001 work]$ cp -a $OPENGGCMDIR/run-template/test0003/{runme,swdata} test0003/
(ggcm) [kaig@ln-0001 work]$ cd test0003
(ggcm) [kaig@ln-0001 test0003]$ ./runme
[...]
```

Get a coffee and cross your fingers...

Once the build successfully finishes, one should make a batch script and submit
a job.

```{todo}
Really, the `runme` should be adapted to make a batch script for Marvin here.
```

But for now, we'll just run the code by hand.

```sh
(ggcm) [kaig@ln-0001 test0003]$ cd target
(ggcm) [kaig@ln-0001 target]$ srun -n 6 ./openggcm
srun: job 27370 queued and waiting for resources
```

Well, since the queue is full, I just ran on the head node:

```sh
(ggcm) [kaig@ln-0001 target]$ mpirun -n 6 ./openggcm
[...]
```

This run is set up to be a tiny test case, so it only runs for a minute or so.
But it should produce some MHD and ionosphere output files that can be plotted
using ggcmpy as shown in the
[sample notebook](../getting-started-guide/quick-overview.ipynb).

# Getting Started

Most of ggcmpy is actually invisible to the user -- it provides backends to the
[Xarray](https://xarray.dev) library that "makes working with labelled
multi-dimensional arrays in Python simple, efficient, and fun!"

```{toctree}
:maxdepth: 2
:hidden:

installing
quick-overview
solarwind
faq
```

# ggcmpy Documentation

_Python Utilities for the OpenGGCM Global Magnetosphere Code_

```{toctree}
:maxdepth: 2
:hidden:

Getting Started <getting-started-guide/index>
API <api/index>

OpenGGCM <openggcm/index>
```

```{include} ../README.md
:start-after: <!-- SPHINX-START -->
```

## Indices and tables

- {ref}`genindex`
- {ref}`modindex`
- {ref}`search`

# OpenGGCM

```{note}
This isn't really the right place for general OpenGGCM documentation. It should be moved, eventually, but I gotta start somewhere. Things need to be consolidated, too (see https://openggcm.sr.unh.edu/?n=Main.Running)
```

```{toctree}
:maxdepth: 2
:hidden:

Installing and Running <quickstart>
```

# Installation

To install the package from PyPI, you can use `pip`. Open your terminal and run
the following command:

```sh
pip install ggcmpy
```

Alternatively, you can do the same through

```sh
python -mpip install ggcmpy
```

This will download and install the latest version of the package from the Python
Package Index (PyPI).

ggcmpy uses an extension written in Fortran to read OpenGGCM jrlle custom binary
format, which means it contains binary code. We currently provide binary
"wheels" for Linux x86_64-based systems, but not yet for other architectures and
operating systems. If no binary wheel is available for your use case, the
command above will download the source and compile the code on your system --
however, this means that you'll need to having a working set of compilers
(gfortran) and libraries installed.

To verify the installation, you can run:

```sh
pip show ggcmpy
```

This will display information about the installed package.

## Required dependencies

Required dependencies will be automatically if you use `pip` to install ggcmpy
as shown above. Currently, `ggcmpy` has these required dependencies:

- xarray
- dask

The "dask" library helps to distribute array operations, but that should usually
happen under the hood and be visible to the user. At the current time, however,
`xarray.open_mfdataset()` needs dask to be installed to work.
